/*
 * Created by SharpDevelop.
 * User: Freddie Nash
 * Date: 09/08/2010
 * Time: 13:53
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using gl = Tao.OpenGl.Gl;
using glut = Tao.FreeGlut.Glut;

namespace Planar
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm : Form
	{

		public class animg
		{
        		
    		public Image[] imgs;
    		public int[] delays;
    		public int runTime, maxRunTime;
    		public string stringEq;
    		public bool loopBack = true;
    		public int repeat;
    		
    		public uint[][] imgsGL;
    		
    		public void inc()
    		{
    			if (loopBack && runTime == maxRunTime - 1)
    				runTime = repeat;
    			else if (runTime < maxRunTime - 1)
    				runTime++;
    		}
    		
    		public Image curImg()
    		{
				int cDelay = 0;
    			for (int i = 0; i < delays.Length; i++)
    			{
    				cDelay += delays[i];
    				if (cDelay > runTime)
    					return imgs[i];
	  	  		}
	  	  		
	  	  		return imgs[0];
      	  	}
      	  	
      	  	public uint[] curImgGL()
      	  	{
					int cDelay = 0;
        			for (int i = 0; i < delays.Length; i++)
        			{
        				cDelay += delays[i];
        				if (cDelay > runTime)
        					return imgsGL[i];
        			}
        			
    			return imgsGL[0];
    		}
    		
    		public animg clone()
    		{
    			return new animg(stringEq);
    		}
    		
    		public animg semiClone()
    		{
    			animg output = new MainForm.animg();
    			output.imgs = imgs;
    			output.imgsGL = imgsGL;
    			output.delays = delays;
    			output.loopBack = loopBack;
    			return output;
    		}
    			
    		public animg() { }
    		
    		public animg(string s)
			{
    			repeat = 0;
	  	  		stringEq = s;
	  	  		if (s.StartsWith("*noloop;"))
	  	  		{
	  	  			loopBack = false;
	  	  			s = s.Remove(0, 8);
	  	  		}
	  	  		string[] data = s.Split(':');
				
				imgs = new Image[(int)(data.Length / 2)];
				delays = new int[(int)(data.Length / 2)];
				
				imgsGL = new uint[(int)(data.Length / 2)][];
				
				int cDelay = 0;
				for (int i = 0; i < data.Length; i += 2)
				{
					
					if (data[i].StartsWith("*repeat;"))
					{
						data[i] = data[i].Substring(8);
						repeat = cDelay + 1;
					}
					
					delays[(int)(i / 2)] = int.Parse(data[i + 1]);
					cDelay += delays[(int)(i / 2)];
					
					imgs[(int)(i / 2)] = Image.FromFile(data[i]);
					imgsGL[(int)(i / 2)] = funcs.getTexture(imgs[(int)(i / 2)]);
				}
				
				maxRunTime = cDelay;
				
			}
    		
    		public void empty()
    		{
    			for (int i = imgsGL.Length - 1; i >= 0; i--)
    			{
//        			gl.glDeleteTextures(1, imgsGL[i]);
					imgs[i].Dispose();
    			}
    		}
    		
    		~animg()
    		{
    			empty();
    		}
        	
		}
		
		public class obj
		{
			public animg img;
			public bool foreGround;
			public PointF[] points;
			public SizeF calcSize;
			
			public string name;
			
			public PointF[] getPoints(PointF loc, SizeF size)
			{
				PointF[] output = new PointF[4];
				output[0] = loc;
				output[1] = new PointF(loc.X + size.Width, loc.Y);
				output[2] = new PointF(loc.X + size.Width, loc.Y + size.Height);
				output[3] = new PointF(loc.X, loc.Y + size.Height);
				return output;
			}
			
			public obj() { }
			
			public obj(SizeF sizeN)
			{
				calcSize = sizeN;
			}
			
			public obj(PointF locN, string imgStr, bool foreGroundN)
			{
				img = new MainForm.animg(imgStr);
				points = getPoints(locN, img.curImg().Size);
				calcSize = img.curImg().Size;
				foreGround = foreGroundN;
				name = "";
			}
			
			public obj(PointF locN, SizeF sizeN, string imgStr, bool foreGroundN)
			{
				img = new MainForm.animg(imgStr);
				points = getPoints(locN, sizeN);
				calcSize = sizeN;
				foreGround = foreGroundN;
				name = "";
			}
			
			public void movePoints(float x, float y)
			{
				for (int i = 0; i < points.Length; i++)
				{
					points[i].X += x;
					points[i].Y += y;
				}
			}
			
			public void moveTo(PointF locN)
			{
				points = getPoints(locN, calcSize);
			}
			
		}

		public class area
		{
			/// <summary>Offset rectangles</summary>
			public List<RectangleF> rects = new List<RectangleF>();
			
			public area(string str)
			{
				string[] parts = str.Split(':');
				string[] data;
				foreach (string s in parts)
				{
					data = s.Split(',');
					rects.Add(new RectangleF(float.Parse(data[0]), float.Parse(data[1]), float.Parse(data[2]), float.Parse(data[3])));
				}
			}
		}
		
		public class body
		{
			public List<oBoundry> lines = new List<MainForm.oBoundry>();
			public Dictionary<string, animg> animgs = new Dictionary<string, animg>();
			public Dictionary<string, area> areas = new Dictionary<string, area>();
			public Dictionary<string, System.Media.SoundPlayer> sounds = new Dictionary<string, System.Media.SoundPlayer>();
			public PointF loc; // top left corner
			public PointF vel;
			public float legLength, legInset;
			public string state, subState; // walking/standing/falling etc.
			public SizeF size;
			public bool onGround;
			public bool dead, win;
			public bool flipImg;
			public string name;
			public float mass = 1.0f;
			public float area = 1.0f;
			public float jump = 10.0f;
			
			public float maxSpeed = 5.0f;
			public float deathSpeed = 50.0f;
			public float accel = 1.0f;
			
			public string killed = "";
			public bool canDie = true;
			
			public string burned = "";
			public bool burning = false;
			
			public bool goLeft, goRight, goUp;
			
			public bool disabled;
			
			public body(string nameN)
			{
				name = nameN;
				state = "fall";
				subState = "slope";
				legLength = 0.0f;
			}
			
			public string fullState()
			{
				if (animgs.ContainsKey(state + "-" + subState))
					return state + "-" + subState;
				else
					return state;
			}
			
			public void addLine(int type, PointF o1, PointF o2)
			{
				lines.Add(new oBoundry(type, new PointF(o1.X + loc.X, o1.Y + loc.Y), new PointF(o2.X + loc.X, o2.Y + loc.Y), o1, o2));
			}
			
			public void offsetLines()
			{
				foreach (oBoundry ol in lines)
				{
					ol.line.p1 = new PointF(ol.o1.X + loc.X, ol.o1.Y + loc.Y);
					ol.line.p2 = new PointF(ol.o2.X + loc.X, ol.o2.Y + loc.Y);
				}
			}
			
			public bool containsLine(Boundry b)
			{
				foreach (oBoundry o in lines)
				{
					if (o.line == b)
						return true;
				}
				return false;
			}
			
			~body()
			{
				win = false;
			}
			
		}
		
		public class Boundry
		{
			/// <summary>
			/// Type of boundry, 0 = contact, 1 = kill, 2 = win, 3 = rotate, 4 = other (non-contact)
			/// </summary>
			public int type;
			/// <summary>
			/// Points
			/// </summary>
			public PointF p1, p2;
			/// <summary>
			/// Angle (optional) of plane rotation
			/// </summary>
			public float angle;
			
			/// <summary>
			/// Name (optional) of the boundry
			/// </summary>
			public string name;
			/// <summary>
			/// Code run upon Trigger
			/// </summary>
			public string trigger;
			
			/// <summary>
			/// Triggered when invoked?
			/// </summary>
			public bool invoked;
			
			public Boundry () { }
			
			public Boundry(int typeN, PointF p1N, PointF p2N)
			{
				type = typeN;
				p1 = p1N;
				p2 = p2N;
				name = "";
				trigger = "";
			}
		}
		
		public class oBoundry
		{
			public PointF o1;
			public PointF o2;
			public Boundry line;
			
			public oBoundry(int typeN, PointF p1N, PointF p2N, PointF o1N, PointF o2N)
			{
				o1 = o1N;
				o2 = o2N;
				line = new MainForm.Boundry(typeN, p1N, p2N);
			}
		}
		
		public class dust
		{
			public PointF loc;
			public PointF vel;
			public Color colour;
			
			public dust(PointF locN, PointF velN, Color colourN)
			{
				loc = locN;
				vel = velN;
				colour = colourN;
			}
		}
		
		public class fire
		{
			public PointF loc;
			public PointF vel;
			public Color colour;
			public float xAim;
			
			public fire(PointF locN, PointF velN, float xAimN)
			{
				loc = locN;
				vel = velN;
				colour = Color.FromArgb(255, 100, 0);
				xAim = xAimN;
			}
			
			public fire(PointF locN, PointF velN)
			{
				loc = locN;
				vel = velN;
				colour = Color.FromArgb(255, 100, 0);
				xAim = loc.X + vel.X / 3.0f;
			}
		}
		
		public class fluid
		{
			public PointF loc;
			public PointF vel;
			public Color colour;
			public bool flamable;
			
			public fluid(PointF locN, PointF velN, Color colourN, bool flamableN)
			{
				loc = locN;
				vel = velN;
				colour = colourN;
				flamable = flamableN;
			}
		}

		public class script
		{
			public string name;
			public string[] lines;
			public int line;
			public int wait = -1;
			
			public script(string nameN, string[] linesN)
			{
				name = nameN;
				lines = linesN;
			}
			
			public script(string nameN, string path)
			{
				name = nameN;
				System.IO.StreamReader reader = new System.IO.StreamReader(path);
				lines = reader.ReadToEnd().Replace("\r", "").Split('\n');
				reader.Close();
				reader.Dispose();
			}
			
			public string curLine()
			{
				if (line != -1)
					return lines[line];
				return "";
			}
			
			public void stop()
			{
				line = -1;
			}
			
			public void start()
			{
				line = 0;
			}
			
			public void inc()
			{
				again:
				if (line == -1)
					return;
				line++;
				if (line == lines.Length - 1 || lines[line].ToLower().StartsWith("ret"))
					line = 0;
				else if (lines[line].StartsWith("wait "))
				{
					if (wait == -1)
						wait = int.Parse(lines[line].Substring(5));
					else if (wait == 0)
					{
						wait = -1;
						goto again;
					}
					wait--;
				}
				else if (line >= lines.Length)
					line = -1;
			}
		
			public void replace(string oldStr, string newStr)
			{
				for (int i = 0; i < lines.Length; i++)
				{
					lines[i] = lines[i].Replace(oldStr, newStr);
				}
			}
		
			public void replacex(string str)
			{
				string[] data = str.Split(' ');
				str = str.Substring(data[0].Length + 1);
				int loc = str.IndexOf(data[0]);
				replace(str.Substring(0, loc - 1), str.Substring(loc + data[0].Length + 1));
			}
		}
		
		public List<obj> objs = new List<obj>();
		public List<Boundry> boundries = new List<Boundry>();
		public List<dust> dusts = new List<dust>();
		public List<fire> fires = new List<fire>();
		public List<fluid> fluids = new List<fluid>();
		public List<script> scripts = new List<script>();
		public List<body> bodies = new List<body>();
		public Dictionary<string, PointF> points = new Dictionary<string, PointF>();
		public Dictionary<string, string> strings = new Dictionary<string, string>();
		public Dictionary<string, animg> animgs = new Dictionary<string, animg>();
		public body player;
		public Image bgImg;
		string curLevel, nextLevel;
		public int colls = 0;
		
		public List<Boundry> ignoreLines = new List<MainForm.Boundry>();
		
		public Dictionary<string, System.Media.SoundPlayer> sounds = new Dictionary<string, System.Media.SoundPlayer>();
		public bool sound = true;
		
		public bool editorMode;
		public PointF mouse;
		public int mouses = 0;
		
		public string commonName = "player";
		public string curBody = "player";
		
		public Bitmap img;
		public Graphics g;
		
		public bool canRotate = false;
		public bool debugDraws, noBGDraw;
		public bool[] keysDown;
		public Dictionary<string, string> keyMaps = new Dictionary<string, string>();
		public Dictionary<string, uint[]> renders = new Dictionary<string, uint[]>();
		
		public float planeAngle = 0.0f;
		public PointF planeOffset;
		
		public bool noDraw;
		
		public int brightness;
		public float warningGlow = 1.0f;
		public bool warning = false;
		
		public Color PlanarBlue = Color.FromArgb(255, 75, 130, 180);
		
		public Random rnd = new Random();
		
		console con;
		VNumParser vn = new VNumParser();
		
		public bool showMenu, loading;
		
		// GL Stuffss
		public bool useGL = true, gdiPaintOverride = true;
//		public Tao.Platform.Windows.SimpleOpenGlControl glControl;
		public int textGlow = 0;
		Font font1 = new Font("Tahoma", 50, FontStyle.Regular); // big font == good qulatity
		
		// FPSNess
		public System.Diagnostics.Stopwatch fpsWatch = new System.Diagnostics.Stopwatch();
		public int frameCount = 0;
		
		// env
		public float envGravity = 0.6f;
		public float envDrag = 0.01f;
		public float envShake;
		
		public MainForm()
		{
			InitializeComponent();
			
			init();
		}
		
		public void init()
		{
			execFile("startup.txt");
			// inital stuff
			keysDown = new bool[256];
			curLevel = "data/levels/level0.txt";
			con = new console(this);
			// inital graphics
			if (useGL)
			{
				initGL();
				return;
			}
			if (!gdiPaintOverride)
			{
				img = new Bitmap(600, 400);
				this.BackgroundImage = img;
				g = Graphics.FromImage(img);
				g.SetClip(new Rectangle(0, 0, 600, 400));
			}
		}
		
		public void initGL()
		{
			
			// old glu
//			glControl = new Tao.Platform.Windows.SimpleOpenGlControl();
//			this.Controls.Add(glControl);
//			glControl.Dock = DockStyle.Fill;
//			glControl.InitializeContexts();
//			
//			glControl.KeyDown += new KeyEventHandler(this.MainFormKeyDown);
//			glControl.KeyUp += new KeyEventHandler(this.MainFormKeyUp);
			
			// new glut
			glut.glutInit();
			glut.glutInitDisplayMode(glut.GLUT_DOUBLE | glut.GLUT_RGB);
			
			glut.glutInitWindowSize(600, 400);
			glut.glutCreateWindow("Planar Glut");
			
			glut.glutMouseFunc(new glut.MouseCallback(mouseFunc));
			
			gl.glEnable(gl.GL_TEXTURE_2D);
			gl.glEnable(gl.GL_BLEND);
			gl.glBlendFunc(gl.GL_SRC_ALPHA, gl.GL_ONE_MINUS_SRC_ALPHA);
			
			gl.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
			
			gl.glViewport(0, 0, 600, 400);
			
			gl.glMatrixMode(gl.GL_PROJECTION);
			gl.glLoadIdentity();
			gl.glOrtho(0, 600, 400, 0, 0, 1);
			gl.glMatrixMode(gl.GL_MODELVIEW);
			gl.glLoadIdentity();
			gl.glEnable(gl.GL_LINE_SMOOTH);

			gl.glPointSize(2);
			
			gl.glLoadIdentity();
			
			renders.Add("title", funcs.renderGLText("Planar", font1, PlanarBlue));
			renders.Add("loading", funcs.renderGLText("Loading...", font1, PlanarBlue));
			renders.Add("warning", funcs.renderGLText("Warning", font1, Color.Red));
			renders.Add("injury", funcs.renderGLText("Injury", font1, Color.Red));
			
//			gl.glDisable(gl.GL_DEPTH_TEST);
//			gl.glDepthMask(gl.GL_FALSE);
//			gl.glClear(gl.GL_COLOR_BUFFER_BIT);
//			
//			
//			gl.glBlendColor(0.0f, 0.0f, 0.0f, 0.0f);
			
		}
		
		public float degRad(float degrees)
		{
			return degrees / 180.0f * (float)Math.PI;
		}
		
		public PointF rotate(float angle, PointF origin, PointF point)
		{
			PointF output = new PointF();
			output.X = origin.X + (point.X - origin.X) * (float)Math.Cos(degRad(angle)) - (point.Y - origin.Y) * (float)Math.Sin(degRad(angle));
			output.Y = origin.Y + (point.Y - origin.Y) * (float)Math.Cos(degRad(angle)) + (point.X - origin.X) * (float)Math.Sin(degRad(angle));
			return output;
		}
		
		public void subRotatePlane(float angle, PointF origin)
		{
			foreach (Boundry b in boundries)
			{
				b.p1 = rotate(angle, origin, b.p1);
				b.p2 = rotate(angle, origin, b.p2);
			}
			foreach (obj o in objs)
			{
				for (int i = 0; i < 4; i++)
					o.points[i] = rotate(angle, origin, o.points[i]);
			}
			foreach (body b in bodies)
			{
				if (b.name != player.name)
				{
					b.loc = rotate(angle, origin, b.loc);
				}
			}
			
			foreach (dust d in dusts)
				d.loc = rotate(angle, origin, d.loc);
			
			List<string> keys = new List<string>(points.Keys);
			for (int i = 0; i < points.Count; i++)
				points[keys[i]] = rotate(angle, origin, points[keys[i]]);
		}
		
		public void rotatePlane(float angle, PointF origin)
		{
			planeOffset = rotate(planeAngle, origin, planeOffset);
			planeAngle += angle;
			for (int i = 0; i < Math.Abs(angle); i++)
			{
				if (brightness <= 100)
					brightness += 6;
				draw();
				subRotatePlane(Math.Sign(angle), origin);
			}
			brightness = 150;
			draw();
		}
		
//		public void rotatePlane(float angle, PointF origin)
//		{
//			brightness = 100;
//			planeOffset = rotate(planeAngle, origin, planeOffset);
//			planeAngle += angle;
//			foreach (Boundry b in boundries)
//			{
//				b.p1 = rotate(angle, origin, b.p1);
//				b.p2 = rotate(angle, origin, b.p2);
//			}
//			foreach (obj o in objs)
//			{
//				for (int i = 0; i < 4; i++)
//					o.points[i] = rotate(angle, origin, o.points[i]);
//			}
//			//player.loc = rotate(angle, origin, player.loc);
//		}
		
		public void emptyRender(string renderKey)
		{
			if (renders.ContainsKey(renderKey))
			{
//				free graphics thingy
				renders.Remove(renderKey);
			}
		}
		
		public void addToLevelList(string levelAlias, string levelPath)
		{
			string[] lines = System.IO.File.ReadAllLines("levels.txt");
			if (Array.IndexOf<string>(lines, levelAlias + "::" + levelPath) == -1)
			{
				System.IO.StreamWriter writer = System.IO.File.AppendText("levels.txt");
				writer.Write("\n" + levelAlias + "::" + levelPath);
				writer.Close();
				writer.Dispose();
			}
			
		}
		
		public void loadLevel(string filename)
		{
			
			timer1.Stop();
			
			loading = true;
			if (player != null)
				draw();
			
			bodies.Clear();
			objs.Clear();
			boundries.Clear();
			scripts.Clear();
			planeAngle = 0;
			planeOffset = new PointF(0.0f, 0.0f);
			brightness = 150;
			player = new body("player");
			player.state = "still"; //don't use setBodyState
			bodies.Add(player);
			player.animgs.Clear();
			envGravity = 0.6f;
			animgs.Clear();
			points.Clear();
			strings.Clear();
			foreach (string k in sounds.Keys)
				sounds[k].Dispose();
			sounds.Clear();
			
			loadFile(filename);
			
			frameCount = 0;
			fpsWatch.Reset();
			fpsWatch.Start();
			
			loading = false;
			
			timer1.Start();
			
		}
		
		public void loadFile(string filename)
		{
			System.IO.StreamReader reader = new System.IO.StreamReader(filename);
			
			while (!reader.EndOfStream)
			{
				loadLine(reader.ReadLine());
			}
			
			reader.Close();
		}
		
		public string varify(string s)
		{
			s = s.Replace("<cname>", commonName).Replace("<cbody>", curBody);
			if (s.Contains("<tbody>"))
			{
				float dist = 100;
				int curBest = -1;
				for (int i = 0; i < bodies.Count; i++)
				{
					if (bodies[i].name != player.name && Math.Abs(player.loc.Y - bodies[i].loc.Y) < 20 && Math.Abs(player.loc.X - bodies[i].loc.X) < dist)
					{
						curBest = i;
						dist = Math.Abs(player.loc.X - bodies[i].loc.X);
					}
				}
				if (curBest != -1)
					s = s.Replace("<tbody>", bodies[curBest].name);
				else
					return "";
			}
			while (s.Contains("<rnd>"))
				s = s.Substring(0, s.IndexOf("<rnd>")) + rnd.NextDouble().ToString() + s.Substring(s.IndexOf("<rnd>") + 5);
			if (s.Contains("["))
			{
				foreach (string k in points.Keys)
					s = s.Replace("p[" + k + "]", points[k].X.ToString() + " " + points[k].Y.ToString()).Replace("p[" + k + ".x]", points[k].X.ToString()).Replace("p[" + k + ".y]", points[k].Y.ToString());
				foreach (string k in strings.Keys)
					s = s.Replace("s[" + k + "]", strings[k]);
				foreach (body b in bodies)
					s = s.Replace("b[" + b.name + "]", b.loc.X.ToString() + " " + b.loc.Y.ToString()).Replace("b[" + b.name + ".x]", b.loc.X.ToString()).Replace("b[" + b.name + ".y]", b.loc.Y.ToString());
			}
			
			string extract, result;
			while (s.Contains("{"))
			{
				extract = s.Substring(s.IndexOf('{') + 1, s.IndexOf('}') - s.IndexOf('{') - 1);
				result = vn.tryParse(extract, false, false);
				if (result == "FAILED!")
					return "";
				s = s.Replace("{" + extract + "}", result);
			}
			
			if (s.Contains("#"))
			{
				for (int i = 0; i < s.Length; i++)
				{
					if (s.Substring(i, 1) == "#")
						s = s.Remove(i, 1);
					while (s.Substring(i, 1) == "#")
						i++;
				}
			}
			
			return s;
		}
		
		public void loadLine(string s)
		{
			s = varify(s);
			
			string[] data = s.Split(' ');
			
			if (data.Length == 0 || s.StartsWith("//"))
				return;
			
			body body1;
			
			switch (data[0])
			{
				case "named":
					loadLineNamed(s.Substring(data[0].Length + data[1].Length + 2), data[1]);
					break;
				case "line":
					boundries.Add(new Boundry(int.Parse(data[1]), new PointF(float.Parse(data[2]), float.Parse(data[3])), new PointF(float.Parse(data[4]), float.Parse(data[5]))));
					if (data[1] == "3")
						boundries[boundries.Count - 1].angle = float.Parse(data[6]);
					break;
				case "line_attached":
					body1 = getBody(data[1]);
					body1.addLine(int.Parse(data[2]), new PointF(float.Parse(data[3]), float.Parse(data[4])), new PointF(float.Parse(data[5]), float.Parse(data[6])));
					if (data[2] == "3")
						body1.lines[body1.lines.Count - 1].line.angle = float.Parse(data[7]);
					boundries.Add(body1.lines[body1.lines.Count - 1].line);
					break;
				case "rect":
					boundries.Add(new Boundry(int.Parse(data[1]), new PointF(float.Parse(data[2]), float.Parse(data[3])), new PointF(float.Parse(data[2]), float.Parse(data[5]))));
					boundries.Add(new Boundry(int.Parse(data[1]), new PointF(float.Parse(data[4]), float.Parse(data[5])), new PointF(float.Parse(data[2]), float.Parse(data[5]))));
					boundries.Add(new Boundry(int.Parse(data[1]), new PointF(float.Parse(data[4]), float.Parse(data[5])), new PointF(float.Parse(data[4]), float.Parse(data[3]))));
					boundries.Add(new Boundry(int.Parse(data[1]), new PointF(float.Parse(data[2]), float.Parse(data[3])), new PointF(float.Parse(data[4]), float.Parse(data[3]))));
					break;
				case "circle":
					int type = int.Parse(data[1]);
					float radius = float.Parse(data[2]);
					int num = int.Parse(data[3]);
					PointF center = new PointF(float.Parse(data[4]), float.Parse(data[5]));
					for (int i = 0; i < num; i++)
					{
						boundries.Add(new Boundry(type, rotate(360.0f / (float)num * (float)i, center, new PointF(center.X, center.Y - radius)), rotate(360.0f / (float)num * (float)(i + 1), center, new PointF(center.X, center.Y - radius))));
					}
					break;
				case "poly":
					for (int i = 0; i < (data.Length - 4) / 2; i++)
						boundries.Add(new Boundry(int.Parse(data[1]), new PointF(float.Parse(data[2 + (i * 2)]), float.Parse(data[3 + (i * 2)])), new PointF(float.Parse(data[4 + (i * 2)]), float.Parse(data[5 + (i * 2)]))));
					break;
				case "poly_closed":
					for (int i = 0; i < (data.Length - 4) / 2; i++)
						boundries.Add(new Boundry(int.Parse(data[1]), new PointF(float.Parse(data[2 + (i * 2)]), float.Parse(data[3 + (i * 2)])), new PointF(float.Parse(data[4 + (i * 2)]), float.Parse(data[5 + (i * 2)]))));
					boundries.Add(new Boundry(int.Parse(data[1]), new PointF(float.Parse(data[2]), float.Parse(data[3])), new PointF(float.Parse(data[data.Length - 2]), float.Parse(data[data.Length - 1]))));
					break;
				case "bgimg":
					bgImg = Image.FromFile(s.Substring(data[0].Length + 1));
					objs.Add(new obj(new PointF(0.0f, 0.0f), s.Substring(data[0].Length + 1) + ":1", false));
					objs[objs.Count - 1].name = "BG";
					break;
				case "player_animg":
					player.animgs.Add(data[1], newAnimg(s.Substring(data[0].Length + data[1].Length + 2)));
					break;
				case "player_rects":
					player.areas.Add(data[1], new area(s.Substring(data[0].Length + data[1].Length + 2)));
					break;
				case "player_start":
					player.loc = new PointF(float.Parse(data[1]), float.Parse(data[2]));
					break;
				case "player_size":
					player.size = new SizeF(float.Parse(data[1]), float.Parse(data[2]));
					break;
				case "player_max_speed":
					player.maxSpeed = float.Parse(data[1]);
					break;
				case "player_death_speed":
					player.deathSpeed = float.Parse(data[1]);
					break;
				case "player_accel":
					player.accel = float.Parse(data[1]);
					break;
				case "player_mass":
					player.mass = float.Parse(data[1]);
					break;
				case "next_level":
					nextLevel = s.Substring(data[0].Length + 1);
					break;
				case "add_std_off_board_killers":
					boundries.Add(new Boundry(1, new PointF(-200, -200), new PointF(-200, bgImg.Height + 200)));
					boundries.Add(new Boundry(1, new PointF(-200, -200), new PointF(bgImg.Width + 200, -200)));
					boundries.Add(new Boundry(1, new PointF(bgImg.Width + 200, bgImg.Height + 200), new PointF(-200, bgImg.Height + 200)));
					boundries.Add(new Boundry(1, new PointF(bgImg.Width + 200, bgImg.Height + 200), new PointF(bgImg.Width + 200, -200)));
					break;
				case "b_obj":
					objs.Add(new obj(new PointF(float.Parse(data[1]), float.Parse(data[2])), s.Substring(data[0].Length + data[1].Length + data[2].Length + 3), false));
					break;
				case "f_obj":
					objs.Add(new obj(new PointF(float.Parse(data[1]), float.Parse(data[2])), s.Substring(data[0].Length + data[1].Length + data[2].Length + 3), true));
					break;
				case "a_b_obj":
					objs.Add(new obj(new PointF(float.Parse(data[1]), float.Parse(data[2])), new SizeF(float.Parse(data[3]), float.Parse(data[4])), s.Substring(data[0].Length + data[1].Length + data[2].Length + data[3].Length + data[4].Length + 5), false));
					break;
				case "a_f_obj":
					objs.Add(new obj(new PointF(float.Parse(data[1]), float.Parse(data[2])), new SizeF(float.Parse(data[3]), float.Parse(data[4])), s.Substring(data[0].Length + data[1].Length + data[2].Length + data[3].Length + data[4].Length + 5), true));
					break;
				case "exec":
					exec(s.Substring(5));
					break;
				case "exec_file":
					execFile(s.Substring(10));
					break;
				case "load_file":
					loadFile(s.Substring(10));
					break;
				case "can_rotate":
					canRotate = funcs.boolParse(s.Substring(11));
					break;
				case "body_animg":
					getBody(data[1]).animgs.Add(data[2], newAnimg(s.Substring(data[0].Length + data[1].Length + data[2].Length + 3)));
					break;
				case "body_rects":
					getBody(data[1]).areas.Add(data[2], new area(s.Substring(data[0].Length + data[1].Length + data[2].Length + 3)));
					break;
				case "body_sound":
					body1 = getBody(data[1]);
					body1.sounds.Add(data[2], new System.Media.SoundPlayer(s.Substring(data[0].Length + data[1].Length + data[2].Length + 3)));
					body1.sounds[data[2]].Load();
					break;
				case "body_start":
					getBody(data[1]).loc = new PointF(float.Parse(data[2]), float.Parse(data[3]));
					break;
				case "body_size":
					getBody(data[1]).size = new SizeF(float.Parse(data[2]), float.Parse(data[3]));
					break;
				case "body_max_speed":
					getBody(data[1]).maxSpeed = float.Parse(data[2]);
					break;
				case "body_death_speed":
					getBody(data[1]).deathSpeed = float.Parse(data[2]);
					break;
				case "body_accel":
					getBody(data[1]).accel = float.Parse(data[2]);
					break;
				case "body_mass":
					getBody(data[1]).mass = float.Parse(data[2]);
					break;
				case "body_jump":
					getBody(data[1]).jump = float.Parse(data[2]);
					break;
				case "body_area":
					getBody(data[1]).area = float.Parse(data[2]);
					break;
				case "body_can_die":
					getBody(data[1]).canDie = funcs.boolParse(data[2]);
					break;
				case "body_burned":
					getBody(data[1]).burned = s.Substring(data[1].Length + 13);
					break;
				case "body_killed":
					getBody(data[1]).killed = s.Substring(data[1].Length + 13);
					break;
				case "body_leg_length":
					getBody(data[1]).legLength = float.Parse(s.Substring(data[1].Length + 17));
					break;
				case "body_leg_inset":
					getBody(data[1]).legInset = float.Parse(s.Substring(data[1].Length + 16));
					break;
				case "level_alias":
					addToLevelList(curLevel, s.Substring(12));
					emptyRender("alias");
					renders.Add("alias", funcs.renderGLText(s.Substring(12), font1, PlanarBlue));
					break;
			}
		}
		
		public void loadLineNamed(string s, string name)
		{
			s = varify(s);
			
			string[] data = s.Split(' ');
			
			if (data.Length == 0 || s.StartsWith("//"))
				return;
			
			switch (data[0])
			{
				case "line":
					boundries.Add(new Boundry(int.Parse(data[1]), new PointF(float.Parse(data[2]), float.Parse(data[3])), new PointF(float.Parse(data[4]), float.Parse(data[5]))));
					if (data[1] == "3")
						boundries[boundries.Count - 1].angle = float.Parse(data[6]);
					boundries[boundries.Count - 1].name = name;
					break;
				case "b_obj":
					objs.Add(new obj(new PointF(float.Parse(data[1]), float.Parse(data[2])), s.Substring(data[0].Length + data[1].Length + data[2].Length + 3), false));
					objs[objs.Count - 1].name = name;
					break;
				case "f_obj":
					objs.Add(new obj(new PointF(float.Parse(data[1]), float.Parse(data[2])), s.Substring(data[0].Length + data[1].Length + data[2].Length + 3), true));
					objs[objs.Count - 1].name = name;
					break;
				case "a_b_obj":
					objs.Add(new obj(new PointF(float.Parse(data[1]), float.Parse(data[2])), new SizeF(float.Parse(data[3]), float.Parse(data[4])), s.Substring(data[0].Length + data[1].Length + data[2].Length + data[3].Length + data[4].Length + 5), false));
					objs[objs.Count - 1].name = name;
					break;
				case "a_f_obj":
					objs.Add(new obj(new PointF(float.Parse(data[1]), float.Parse(data[2])), new SizeF(float.Parse(data[3]), float.Parse(data[4])), s.Substring(data[0].Length + data[1].Length + data[2].Length + data[3].Length + data[4].Length + 5), true));
					objs[objs.Count - 1].name = name;
					break;
				case "obj_clone":
					obj obj1 = getObj(data[5]);
					objs.Add(new obj(obj1.calcSize));
					objs[objs.Count - 1].name = name;
					objs[objs.Count - 1].moveTo(new PointF(float.Parse(data[1]), float.Parse(data[2])));
					objs[objs.Count - 1].img = getObj(data[5]).img.semiClone();
					objs[objs.Count - 1].foreGround = getObj(data[5]).foreGround;
					break;
				case "script":
					scripts.Add(new script(name, s.Substring(7)));
					scripts[scripts.Count - 1].replace("<cname>", commonName);
					break;
				case "body":
					bodies.Add(new body(name));
					break;
				case "animg":
					animgs.Add(name, new animg(s.Substring(6)));
					break;
				case "common_body":
					commonName = name;
					loadFile("data/common/cb/" + data[1] + "/new.txt");
					break;
				case "common_body_at":
					commonName = name;
					loadFile("data/common/cb/" + data[1] + "/new.txt");
					getBody(commonName).loc = new PointF(float.Parse(data[2]), float.Parse(data[3]));
					break;
				case "sound":
					sounds.Add(name, new System.Media.SoundPlayer(s.Substring(6)));
					sounds[name].Load();
					break;
			}
		}
		
		public void execFile(string filename)
		{
			System.IO.StreamReader reader = new System.IO.StreamReader(filename);
			
			while (!reader.EndOfStream)
			{
				exec(reader.ReadLine());
			}
			
			reader.Close();
		}
		
		public void exec(string s)
		{
			
			if (s.StartsWith("for"))
			{
				string[] forData = s.Split(' ');
				switch (forData[0])
				{
					case "for":
						for (int i = 0; i < int.Parse(forData[1]); i++)
							exec(s.Substring(5 + forData[1].Length).Replace("<num>", i.ToString()));
						break;
					case "for_all_bodies":
						foreach (body b in bodies)
							exec(s.Substring(15).Replace("<body>", b.name));
						break;
					case "for_other_bodies":
						foreach (body b in bodies)
						{
							if (b.name != forData[1])
								exec(s.Substring(18 + forData[1].Length).Replace("<body>", b.name));
						}
						break;
				}
				return;
			}
			
			string[] data;
			if (s.StartsWith("no_varify"))
			{
				data = s.Substring(10).Split(' ');
			}
			else
			{
				s = varify(s);
				data = s.Split(' ');
			}
			
			obj obj1;
			Boundry boundry1;
			body body1, body2;
			script script1;
			int num;
			
			switch (data[0])
			{
				case "load":
					loadLine(s.Substring(5));
					break;
				case "load_file":
					loadFile(s.Substring(10));
					break;
				case "exec_file":
					execFile(s.Substring(10));
					break;
				case "call":
					call(s.Substring(5));
					break;
				case "req":
					req(s.Substring(4));
					break;
				case "if_rnd":
					if (rnd.NextDouble() <= double.Parse(data[1]))
						exec(s.Substring(8 + data[1].Length));
					break;
				case "if_body_dist_lt":
					body1 = getBody(data[1]);
					body2 = getBody(data[2]);
					if (Math.Sqrt(Math.Pow((double)(body1.loc.X - body2.loc.X), 2.0) + Math.Pow((double)(body1.loc.Y - body2.loc.Y), 2.0)) < double.Parse(data[3]))
						exec(s.Substring(19 + data[1].Length + data[2].Length + data[3].Length));
					break;
				case "if_body_dist_le":
					body1 = getBody(data[1]);
					body2 = getBody(data[2]);
					if (Math.Sqrt(Math.Pow((double)(body1.loc.X - body2.loc.X), 2.0) + Math.Pow((double)(body1.loc.Y - body2.loc.Y), 2.0)) <= double.Parse(data[3]))
						exec(s.Substring(19 + data[1].Length + data[2].Length + data[3].Length));
					break;
				case "if_key_down":
//					if (keysDown[Keys.Parse(Keys.GetUnderlyingType(Keys), data[1])])
//						exec(s.Substring(13 + data[1].Length));
					break;
				case "die":
					die(player);;
					break;
				case "win":
					win();
					break;
				case "set_player_vel":
					player.vel = new PointF(data[1] == "*" ? player.vel.X : float.Parse(data[1]), data[2] == "*" ? player.vel.Y : float.Parse(data[2]));
					break;
				case "rem_player_animg":
					player.animgs.Remove(data[1]);
					break;
				case "rem_line":
					for (int i = 0; i < boundries.Count; i++)
					{
						if (boundries[i].name == data[1])
						{
							boundries.RemoveAt(i);
							break;
						}
					}
					break;
				case "rem_obj":
					for (int i = 0; i < objs.Count; i++)
					{
						if (objs[i].name == data[1])
						{
							objs.RemoveAt(i);
							break;
						}
					}
					break;
				case "set_line_trigger":
					for (int i = 0; i < boundries.Count; i++)
					{
						if (boundries[i].name == data[1])
						{
							boundries[i].trigger = s.Substring(data[0].Length + data[1].Length + 2);
							break;
						}
					}
					break;
				case "set_line_invoked_trigger":
					for (int i = 0; i < boundries.Count; i++)
					{
						if (boundries[i].name == data[1])
						{
							boundries[i].trigger = s.Substring(data[0].Length + data[1].Length + 2);
							boundries[i].invoked = true;
							break;
						}
					}
					break;
				case "move_line":
					moveBoundry(getBoundry(data[1]), float.Parse(data[2]), float.Parse(data[3]));
					break;
				case "set_line_loc":
					boundry1 = getBoundry(data[1]);
					boundry1.p1 = new PointF(float.Parse(data[2]), float.Parse(data[3]));
					boundry1.p2 = new PointF(float.Parse(data[4]), float.Parse(data[5]));
					break;
				case "set_line_type":
					getBoundry(data[1]).type = int.Parse(data[2]);
					break;
				case "set_line_angle":
					getBoundry(data[1]).angle = float.Parse(data[2]);
					break;
				case "set_line_name":
					getBoundry(data[1]).name = data[2];
					break;
				case "line_move_p1_to":
					boundry1 = getBoundry(data[1]);
					float lp1_x = float.Parse(data[3]);
					float lp1_y = float.Parse(data[4]);
					float lp1_dist = float.Parse(data[2]);
					if (boundry1.p1.X > lp1_x)
						lp1_x = -lp1_dist;
					else if (boundry1.p1.X < lp1_x)
						lp1_x = lp1_dist;
					else
						lp1_x = 0;
					if (boundry1.p1.Y > lp1_y)
						lp1_y = -lp1_dist;
					else if (boundry1.p1.Y < lp1_y)
						lp1_y = lp1_dist;
					else
						lp1_y = 0;
					moveBoundry(boundry1, lp1_x, lp1_y);
					break;
				case "line_move_p2_to":
					boundry1 = getBoundry(data[1]);
					float lp2_x = float.Parse(data[3]);
					float lp2_y = float.Parse(data[4]);
					float lp2_dist = float.Parse(data[2]);
					if (boundry1.p2.X > lp2_x)
						lp2_x = -lp2_dist;
					else if (boundry1.p2.X < lp2_x)
						lp2_x = lp2_dist;
					else
						lp2_x = 0;
					if (boundry1.p2.Y > lp2_y)
						lp2_y = -lp2_dist;
					else if (boundry1.p2.Y < lp2_y)
						lp2_y = lp2_dist;
					else
						lp2_y = 0;
					moveBoundry(boundry1, lp2_x, lp2_y);
					break;
				case "set_obj_animg":
					for (int i = 0; i < objs.Count; i++)
					{
						if (objs[i].name == data[1])
						{
							objs[i].img = newAnimg(s.Substring(data[0].Length + data[1].Length + 2));
							break;
						}
					}
					break;
				case "set_obj_loc":
					obj temp = getObj(data[1]);
					temp.points = temp.getPoints(new PointF(float.Parse(data[2]), float.Parse(data[3])), temp.calcSize);
					break;
				case "set_cname":
					commonName = data[1];
					break;
				case "obj_move_to":
					obj1 = getObj(data[1]);
					if (data[3] != "*")
					{
						if (obj1.points[0].X > float.Parse(data[3]))
							obj1.movePoints(-float.Parse(data[2]), 0.0f);
						else if (obj1.points[0].X < float.Parse(data[3]))
							obj1.movePoints(float.Parse(data[2]), 0.0f);
					}
					if (data[4] != "*")
					{
						if (obj1.points[0].Y > float.Parse(data[4]))
							obj1.movePoints(0.0f, -float.Parse(data[2]));
						else if (obj1.points[0].Y < float.Parse(data[4]))
							obj1.movePoints(0.0f, float.Parse(data[2]));
					}
					break;
				case "stop_script":
					getScript(data[1]).stop();
					break;
				case "start_script":
					getScript(data[1]).start();
					break;
				case "script_replace":
					getScript(data[1]).replace(data[2], data[3]);
					break;
				case "script_replacex":
					getScript(data[1]).replacex(s.Substring(17 + data[1].Length));
					break;
				case "script_varify":
					script1 = getScript(data[1]);
					for (int i = 0; i < script1.lines.Length; i++)
						script1.lines[i] = varify(script1.lines[i]);
					break;
				case "set_body_vel":
					body1 = getBody(data[1]);
					body1.vel = new PointF(data[2] == "*" ? body1.vel.X : float.Parse(data[2]), data[3] == "*" ? body1.vel.Y : float.Parse(data[3]));
					break;
				case "set_body_loc":
					getBody(data[1]).loc = new PointF(float.Parse(data[2]), float.Parse(data[3]));
					break;
				case "set_body_name":
					getBody(data[1]).name = data[2];
					break;
				case "set_body_state":
					getBody(data[1]).state = data[2];
					break;
				case "set_body_burning":
					getBody(data[1]).burning = funcs.boolParse(data[2]);
					break;
				case "sound_off":
					sound = false;
					foreach (string k in sounds.Keys)
						sounds[k].Stop();
					break;
				case "sound_on":
					sound = true;
					break;
				case "body_go_left":
					body1 = getBody(data[1]);
					body1.goLeft = true;
					body1.goRight = false;
					break;
				case "body_go_right":
					body1 = getBody(data[1]);
					body1.goLeft = false;
					body1.goRight = true;
					break;
				case "body_go_up":
					getBody(data[1]).goUp = true;
					break;
				case "body_go_up_off":
					getBody(data[1]).goUp = false;
					break;
				case "body_go_off":
					getBody(data[1]).goLeft = false;
					getBody(data[1]).goRight= false;
					getBody(data[1]).goUp = false;
					break;
				case "body_die":
					die(getBody(data[1]));
					break;
				case "body_revive":
					revive(getBody(data[1]));
					break;
				case "body_move_to":
					body1 = getBody(data[1]);
					if (body1.loc.X > float.Parse(data[2]))
					{
						body1.goLeft = true;
						body1.goRight = false;
					}
					if (body1.loc.X < float.Parse(data[2]))
					{
						body1.goLeft = false;
						body1.goRight = true;
					}
					break;
				case "body_follow":
					body1 = getBody(data[1]);
					body2 = getBody(data[2]);
					if (body1 == null || body2 == null)
						return;
					if (Math.Abs(body1.loc.X - body2.loc.X) > (Math.Abs(body1.vel.X) + body2.size.Width + body1.size.Width))
					{
						if (body1.loc.X > body2.loc.X)					    
						{
							body1.goLeft = true;
							body1.goRight = false;
						}
						else if (body1.loc.X < body2.loc.X)
						{
							body1.goLeft = false;
							body1.goRight = true;
						}
					}
					else
					{
						body1.goLeft = false;
						body1.goRight = false;
					}
					if (body1.loc.Y > body2.loc.Y + 3)
						body1.goUp = true;
					else
						body1.goUp = false;
					break;
				case "body_flee":
					body1 = getBody(data[1]);
					body2 = getBody(data[2]);
					if (body1 == null || body2 == null)
						return;
					if (body1.loc.X < body2.loc.X)
					{
						body1.goLeft = true;
						body1.goRight = false;
					}
					if (body1.loc.X > body2.loc.X)
					{
						body1.goLeft = false;
						body1.goRight = true;
					}
					break;
				case "rem_body_animg":
					getBody(data[1]).animgs.Remove(data[2]);
					break;
				case "rem_body":
					for (int i = 0; i < bodies.Count; i++)
					{
						if (bodies[i].name== data[1])
						{
							body1 = bodies[i];
							for (int j = boundries.Count - 1; j >= 0; j--)
							{
								if (body1.containsLine(boundries[j]))
									boundries.RemoveAt(j);
							}
							bodies.RemoveAt(i);
							break;
						}
					}
					break;
				case "timer_stop":
					timer1.Stop();
					break;
				case "timer_start":
					timer1.Start();
					break;
				case "set_timer_interval":
					timer1.Interval = int.Parse(data[1]);
					break;
				case "set_env_gravity":
					envGravity = float.Parse(data[1]);
					break;
				case "set_env_shake":
					envShake = float.Parse(data[1]);
					break;
				case "set_env_drag":
					envDrag = float.Parse(data[1]);
					break;
				case "env_add_sparks":
					addSparks(new PointF(float.Parse(data[1]), float.Parse(data[2])), int.Parse(data[3]), float.Parse(data[4]), Color.FromArgb(int.Parse(data[5]), int.Parse(data[6]), int.Parse(data[7])));
					break;
				case "env_add_fire":
					num = int.Parse(data[3]);
					for (int i = 0; i < num; i++)
						fires.Add(new fire(new PointF(float.Parse(data[1]), float.Parse(data[2])), new PointF((float)rnd.NextDouble() * 6.0f - 3.0f, (float)rnd.NextDouble() * 3.0f)));
					break;
				case "env_add_fluid":
					num = int.Parse(data[3]);
					for (int i = 0; i < num; i++)
						fluids.Add(new fluid(new PointF(float.Parse(data[1]), float.Parse(data[2])), new PointF(float.Parse(data[4]), float.Parse(data[5])), Color.FromArgb(int.Parse(data[6]), int.Parse(data[7]), int.Parse(data[8])), false));
					break;
				case "env_add_flamable_fluid":
					num = int.Parse(data[3]);
					for (int i = 0; i < num; i++)
						fluids.Add(new fluid(new PointF(float.Parse(data[1]), float.Parse(data[2])), new PointF(float.Parse(data[4]), float.Parse(data[5])), Color.FromArgb(int.Parse(data[6]), int.Parse(data[7]), int.Parse(data[8])), true));
					break;
				case "set_no_draw":
					noDraw = funcs.boolParse(data[1]);
					break;
				case "set_512mode":
					funcs.use512textureLimit = funcs.boolParse(data[1]);
					break;
				case "set_16bitmode":
					funcs.use16bitTextureLimit = funcs.boolParse(data[1]);
					break;
				case "set_no_bg":
					noBGDraw = funcs.boolParse(data[1]);
					break;
				case "set_show_menu":
					showMenu = funcs.boolParse(data[1]);
					break;
				case "set_debug_draws":
					debugDraws = funcs.boolParse(data[1]);
					break;
				case "set_use_opengl":
					useGL = funcs.boolParse(data[1]);
					break;
				case "map_key":
					if (keyMaps.ContainsKey(data[1]))
						keyMaps[data[1]] = s.Substring(9 + data[1].Length);
					else
						keyMaps.Add(data[1], s.Substring(9 + data[1].Length));
					break;
				case "unmap_key":
					if (keyMaps.ContainsKey(data[1]))
						keyMaps.Remove(data[1]);
					break;
				case "editor_mode":
					if (funcs.boolParse(data[1]))
					{
						useGL = false;
						init();
						envGravity = 0.0f;
						editorMode = true;
						debugDraws = true;
					}
					else
					{
						envGravity = 0.6f;
						editorMode = false;
						debugDraws = false;
					}
					break;
				case "save_lines":
					System.IO.StreamWriter writer = new System.IO.StreamWriter(data[1]);
					writer.WriteLine("load_file data/loads/normal.txt");
					writer.WriteLine("// lines");
					foreach (Boundry b in boundries)
						writer.WriteLine("line " + b.type.ToString() + " " + b.p1.X.ToString() + " " + b.p1.Y.ToString() + " " + b.p2.X.ToString() + " " + b.p2.Y.ToString());
					writer.Close();
					writer.Dispose();
					break;
				case "set_point":
					if (points.ContainsKey(data[1]))
						points[data[1]] = new PointF(float.Parse(data[2]), float.Parse(data[3]));
					else
						points.Add(data[1], new PointF(float.Parse(data[2]), float.Parse(data[3])));
					break;
				case "set_string":
					if (strings.ContainsKey(data[1]))
						strings[data[1]] = s.Substring(12 + data[1].Length);
					else
						strings.Add(data[1], s.Substring(12 + data[1].Length));
					break;
				case "close":
					Close();
					break;
				case "sound_play":
					if (sound)
						sounds[data[1]].Play();
					break;
				case "sound_play_loop":
					if (sound)
						sounds[data[1]].PlayLooping();
					break;
				case "sound_stop":
					sounds[data[1]].Stop();
					break;
				case "rem_sound":
					sounds.Remove(data[1]);
					break;
				case "set_sound_loc":
					sounds[data[1]].SoundLocation = s.Substring(15 + data[1].Length);
					break;
			}
		}
		
		public void call(string s)
		{
//			Microsoft.CSharp.CSharpCodeProvider cscp = new Microsoft.CSharp.CSharpCodeProvider();
//			System.CodeDom.Compiler.ICodeCompiler icc = cscp.CreateCompiler();
//			System.CodeDom.Compiler.CompilerParameters cp = new System.CodeDom.Compiler.CompilerParameters();
//			
//			cp.GenerateInMemory = true;
		}
		
		public void req(string s)
		{			
			string[] data = s.Split(' ');
			
			switch (data[0])
			{
				case "body_info":
					con.addHistory("body " + data[1] +  " at " + getBody(data[1]).loc.ToString());
					break;
				case "body_list":
					foreach (body b in bodies)
					{
						if (b.name != "")
							con.addHistory(b.name);
					}
					break;
				case "obj_info":
					con.addHistory("obj " + data[1] +  " Point0 at " + getObj(data[1]).points[0].ToString());
					break;
				case "obj_list":
					foreach (obj o in objs)
					{
						if (o.name != "")
							con.addHistory(o.name);
					}
					break;
				case "script_lines":
					foreach (string line in getScript(data[1]).lines)
						con.addHistory(line);
					break;
			}
			
		}
		
		public void moveBoundry(Boundry b, float offsetX, float offsetY)
		{
			if (b.type == 0)
			{
				foreach (body bdy in bodies)
				{
					bool leftCol = false, rightCol = false;
					if (!bdy.areas.ContainsKey(bdy.state))
					{
						if (checkContact(b.p1, b.p2, new PointF(bdy.loc.X + bdy.legInset, bdy.loc.Y + bdy.size.Height + 2), new PointF(bdy.loc.X + bdy.legInset, bdy.loc.Y + bdy.size.Height - bdy.legLength))) // left
							leftCol = true;
						if (checkContact(b.p1, b.p2, new PointF(bdy.loc.X + bdy.size.Width - bdy.legInset, bdy.loc.Y + bdy.size.Height + 2), new PointF(bdy.loc.X + bdy.size.Width - bdy.legInset, bdy.loc.Y + bdy.size.Height - bdy.legLength))) // right
							rightCol = true;

					}
					else
					{
						RectangleF r = bdy.areas[bdy.state].rects[0];
						if (checkContact(b.p1, b.p2, new PointF(bdy.loc.X + r.X + offsetX, bdy.loc.Y + r.Y + r.Height + offsetY - bdy.legLength), new PointF(bdy.loc.X + r.X + offsetX, bdy.loc.Y + r.Y + r.Height + offsetY + 2))) // left
							leftCol = true;
						if (checkContact(b.p1, b.p2, new PointF(bdy.loc.X + r.X + r.Width + offsetX, bdy.loc.Y + r.Y + r.Height + offsetY - bdy.legLength), new PointF(bdy.loc.X + r.X + r.Width + offsetX, bdy.loc.Y + r.Y + r.Height + offsetY + 2))) // right
							rightCol = true;
					}
					
					if (leftCol && rightCol)
					{
						if (!bodyCollides(bdy, offsetX, offsetY))
						{
							bdy.loc.X += offsetX;
							bdy.loc.Y += offsetY;
//							bdy.vel.X += offsetX;
//							bdy.vel.Y += offsetY;
						}
					}
				}
			}
			b.p1.X += offsetX;
			b.p1.Y += offsetY;
			b.p2.X += offsetX;
			b.p2.Y += offsetY;
		}
		
		public body getBody(string name)
		{
			for (int i = 0; i < bodies.Count; i++)
			{
				if (bodies[i].name == name)
				{
					return bodies[i];
				}
			}
			return null;
		}
		
		public obj getObj(string name)
		{
			for (int i = 0; i < objs.Count; i++)
			{
				if (objs[i].name == name)
				{
					return objs[i];
				}
			}
			return null;
		}
		
		public Boundry getBoundry(string name)
		{
			for (int i = 0; i < boundries.Count; i++)
			{
				if (boundries[i].name == name)
				{
					return boundries[i];
				}
			}
			return null;
		}
		
		public script getScript(string name)
		{
			for (int i = 0; i < scripts.Count; i++)
			{
				if (scripts[i].name == name)
					return scripts[i];
			}
			return null;
		}
		
		public animg newAnimg(string s)
		{
			if (s.StartsWith("*preloaded;"))
				return animgs[s.Substring(11)];
			return new animg(s);
		}
		
		public void incAll()
		{
			foreach (obj o in objs)
				o.img.inc();
			
			foreach (body b in bodies)
				b.animgs[b.fullState()].inc();
		}
		
		public void GLDraw()
		{
			
			this.Text = colls.ToString();
			colls = 0;
			
			float shakeX = 0.0f, shakeY = 0.0f;
			if (envShake > 0)
			{
				shakeX = envShake * ((float)rnd.NextDouble() - 0.5f);
				shakeY = envShake * ((float)rnd.NextDouble() - 0.5f);
			}
			
			gl.glClear(gl.GL_COLOR_BUFFER_BIT);
			
			gl.glEnable(gl.GL_TEXTURE_2D);
			
//			player.animgs[player.state].inc();
//			PointF imgLoc = new PointF(player.loc.X - (player.animgs[player.state].curImg().Width - player.size.Width) / 2.0f, player.loc.Y - (player.animgs[player.state].curImg().Height - player.size.Height) / 2.0f);
			gl.glMatrixMode(gl.GL_MODELVIEW);
			
			PointF[] pointsT;
					
			gl.glLoadIdentity();
			
			gl.glTranslatef((300.0f - player.size.Width / 2.0f) - player.loc.X, (200.0f - player.size.Height / 2.0f) - player.loc.Y, 0.0f);
			
			if (envShake > 0)
				gl.glTranslatef(envShake * ((float)rnd.NextDouble() - 0.5f), envShake * ((float)rnd.NextDouble() - 0.5f), 0.0f);

			foreach (obj o in objs)
			{
				if (!o.foreGround)
				{
					
					if (noBGDraw && o.name == "BG")
						continue;
					
					gl.glBindTexture(gl.GL_TEXTURE_2D, o.img.curImgGL()[0]);
								
					gl.glBegin(gl.GL_QUADS);
			
					pointsT = o.points;
					
					gl.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
					gl.glTexCoord2f(0.0f, 0.0f);
					gl.glVertex2f(pointsT[0].X, pointsT[0].Y);
					gl.glTexCoord2f(1.0f, 0.0f);
					gl.glVertex2f(pointsT[1].X, pointsT[1].Y);
					gl.glTexCoord2f(1.0f, 1.0f);
					gl.glVertex2f(pointsT[2].X, pointsT[2].Y);
					gl.glTexCoord2f(0.0f, 1.0f);
					gl.glVertex2f(pointsT[3].X, pointsT[3].Y);
					
					gl.glEnd();
				}
			}
			
			float zeroH, oneH;
			PointF imgLoc;
			
			gl.glLoadIdentity();
		
			gl.glTranslatef((300.0f - player.size.Width / 2.0f) - player.loc.X, (200.0f - player.size.Height / 2.0f) - player.loc.Y, 0.0f);
			
			foreach (body b in bodies)
			{
			
				if (b.disabled)
					continue;
			
				if (envShake > 0)
					gl.glTranslatef(shakeX, shakeY, 0.0f);
				
				gl.glBindTexture(gl.GL_TEXTURE_2D, b.animgs[b.fullState()].curImgGL()[0]);
				
				gl.glBegin(gl.GL_QUADS);

				if (b.vel.X < 0.0)
					b.flipImg = true;
				else if (b.vel.X > 0.0)
					b.flipImg = false;
				
				imgLoc = new PointF(b.loc.X - (b.animgs[b.fullState()].curImg().Width - b.size.Width) / 2.0f, b.loc.Y - (b.animgs[b.fullState()].curImg().Height - b.size.Height) / 2.0f);
			
				if (b.flipImg)
				{
					zeroH = 1.0f;
					oneH = 0.0f;
				}
				else
				{
					zeroH = 0.0f;
					oneH = 1.0f;
				}
				
				gl.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
				gl.glTexCoord2f(zeroH, 0.0f);
				gl.glVertex2f(imgLoc.X, imgLoc.Y);
				gl.glTexCoord2f(oneH, 0.0f);
				gl.glVertex2f(imgLoc.X + b.animgs[b.state].curImg().Width, imgLoc.Y);
				gl.glTexCoord2f(oneH, 1.0f);
				gl.glVertex2f(imgLoc.X + b.animgs[b.state].curImg().Width, imgLoc.Y + b.animgs[b.fullState()].curImg().Height);
				gl.glTexCoord2f(zeroH, 1.0f);
				gl.glVertex2f(imgLoc.X, imgLoc.Y + b.animgs[b.fullState()].curImg().Height);
			
				gl.glEnd();
			}
			
			gl.glLoadIdentity();
			
			gl.glTranslatef((300.0f - player.size.Width / 2.0f) - player.loc.X, (200.0f - player.size.Height / 2.0f) - player.loc.Y, 0.0f);
			
			if (envShake > 0)
				gl.glTranslatef(shakeX, shakeY, 0.0f);
			
			foreach (obj o in objs)
			{
				if (o.foreGround)
				{
			
					gl.glBindTexture(gl.GL_TEXTURE_2D, o.img.curImgGL()[0]);
								
					gl.glBegin(gl.GL_QUADS);
			
					pointsT = o.points;
					
					gl.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
					gl.glTexCoord2f(0.0f, 0.0f);
					gl.glVertex2f(pointsT[0].X, pointsT[0].Y);
					gl.glTexCoord2f(1.0f, 0.0f);
					gl.glVertex2f(pointsT[1].X, pointsT[1].Y);
					gl.glTexCoord2f(1.0f, 1.0f);
					gl.glVertex2f(pointsT[2].X, pointsT[2].Y);
					gl.glTexCoord2f(0.0f, 1.0f);
					gl.glVertex2f(pointsT[3].X, pointsT[3].Y);
					
					gl.glEnd();
				}
			}
			
			gl.glDisable(gl.GL_TEXTURE_2D);
			
			gl.glBegin(gl.GL_POINTS);
			foreach (dust d in dusts)
			{
				gl.glColor4f(d.colour.R / 255.0f, d.colour.G / 255.0f, d.colour.B / 255.0f, d.colour.A / 255.0f);
				gl.glVertex2f(d.loc.X, d.loc.Y);
			}
			foreach (fire f in fires)
			{
				gl.glColor4f(f.colour.R / 255.0f, f.colour.G / 255.0f, f.colour.B / 255.0f, f.colour.A / 255.0f);
				gl.glVertex2f(f.loc.X, f.loc.Y);
			}
			foreach (fluid f in fluids)
			{
				gl.glColor4f(f.colour.R / 255.0f, f.colour.G / 255.0f, f.colour.B / 255.0f, f.colour.A / 255.0f);
				gl.glVertex2f(f.loc.X, f.loc.Y);
			}
			gl.glEnd();
			
			if (debugDraws)
			{
				gl.glBegin(gl.GL_LINES);
				gl.glLineWidth(1.0f);
				
				foreach (Boundry b in boundries) 
				{
					if (b.type == 0)
						gl.glColor3f(1.0f, 1.0f, 0.0f);
					else if (b.type == 1)
						gl.glColor3f(1.0f, 0.0f, 0.0f);
					else if (b.type == 2)
						gl.glColor3f(0.0f, 1.0f, 0.0f);
					else if (b.type == 3)
						gl.glColor3f(0.0f, 1.0f, 1.0f);
					else
						gl.glColor3f(1.0f, 0.0f, 1.0f);
					
					gl.glVertex2f(b.p1.X, b.p1.Y);
					gl.glVertex2f(b.p2.X, b.p2.Y);
				}
				gl.glVertex2d(player.loc.X + player.size.Width, player.loc.Y + player.size.Height + 2);
				gl.glVertex2d(player.loc.X + player.size.Width, player.loc.Y + player.size.Height - player.legLength);
				gl.glVertex2d(player.loc.X, player.loc.Y + player.size.Height + 2);
				gl.glVertex2d(player.loc.X, player.loc.Y + player.size.Height - player.legLength);
				gl.glEnd();
				
				if (player.onGround)
					this.Text = "On Ground";
				else
					this.Text = "!On Ground";
				this.Text += " [" + player.vel.X.ToString() + " " + player.vel.Y + "] at " + (frameCount / (fpsWatch.ElapsedMilliseconds / 1000 + 1)) + " fps";
			}
			
			if (brightness > 0)
			{
				gl.glLoadIdentity();
				gl.glBegin(gl.GL_QUADS);
				gl.glColor4f(1.0f, 1.0f, 1.0f, (float)brightness / 255.0f);
				gl.glVertex2f(0.0f, 0.0f);
				gl.glVertex2f(0.0f, 400.0f);
				gl.glVertex2f(600.0f, 400.0f);
				gl.glVertex2f(600.0f, 0.0f);
				gl.glEnd();
				brightness -= 5;
			}
			if (player.dead)
			{
				gl.glLoadIdentity();
				gl.glBegin(gl.GL_QUADS);
				gl.glColor4f(1.0f, 0.0f, 0.0f, 0.2f);
				gl.glVertex2f(0.0f, 0.0f);
				gl.glVertex2f(0.0f, 400.0f);
				gl.glVertex2f(600.0f, 400.0f);
				gl.glVertex2f(600.0f, 0.0f);
				gl.glEnd();
			}
				
			gl.glEnable(gl.GL_TEXTURE_2D);
			
			if (showMenu)
			{
					
				gl.glLoadIdentity();
				
				gl.glBindTexture(gl.GL_TEXTURE_2D, renders["title"][0]); // Title
				
				gl.glBegin(gl.GL_QUADS);
				
				gl.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
				gl.glTexCoord2f(0.0f, 0.0f);
				gl.glVertex2f(100, 50);
				gl.glTexCoord2f(1.0f, 0.0f);
				gl.glVertex2f(500, 50);
				gl.glTexCoord2f(1.0f, 1.0f);
				gl.glVertex2f(500, 150);
				gl.glTexCoord2f(0.0f, 1.0f);
				gl.glVertex2f(100, 150);
				
				gl.glEnd();
					
				gl.glLoadIdentity();
				
				gl.glBindTexture(gl.GL_TEXTURE_2D, renders["alias"][0]); // Alias
				
				gl.glBegin(gl.GL_QUADS);
				
				gl.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
				gl.glTexCoord2f(0.0f, 0.0f);
				gl.glVertex2f(150, 200);
				gl.glTexCoord2f(1.0f, 0.0f);
				gl.glVertex2f(450, 200);
				gl.glTexCoord2f(1.0f, 1.0f);
				gl.glVertex2f(450, 250);
				gl.glTexCoord2f(0.0f, 1.0f);
				gl.glVertex2f(150, 250);
				
				gl.glEnd();
			}
			
			if (loading)
			{
					
				gl.glLoadIdentity();
				
				gl.glBindTexture(gl.GL_TEXTURE_2D, renders["loading"][0]); // Loading...
				
				gl.glBegin(gl.GL_QUADS);
				
				gl.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
				gl.glTexCoord2f(0.0f, 0.0f);
				gl.glVertex2f(420, 320);
				gl.glTexCoord2f(1.0f, 0.0f);
				gl.glVertex2f(520, 320);
				gl.glTexCoord2f(1.0f, 1.0f);
				gl.glVertex2f(520, 350);
				gl.glTexCoord2f(0.0f, 1.0f);
				gl.glVertex2f(420, 350);
				
				gl.glEnd();
			}
			
			if (player.dead)
			{
					
				gl.glLoadIdentity();
				
				gl.glBindTexture(gl.GL_TEXTURE_2D, renders["injury"][0]); // Injury
				
				gl.glBegin(gl.GL_QUADS);
				
				gl.glColor4f(1.0f, 1.0f, 1.0f, warningGlow);
				gl.glTexCoord2f(0.0f, 0.0f);
				gl.glVertex2f(80, 320);
				gl.glTexCoord2f(1.0f, 0.0f);
				gl.glVertex2f(180, 320);
				gl.glTexCoord2f(1.0f, 1.0f);
				gl.glVertex2f(180, 350);
				gl.glTexCoord2f(0.0f, 1.0f);
				gl.glVertex2f(80, 350);
				
				gl.glEnd();
			}
			else if (warning || envShake > 2.0f || player.burning)
			{
					
				gl.glLoadIdentity();
				
				gl.glBindTexture(gl.GL_TEXTURE_2D, renders["warning"][0]); // Warning
				
				gl.glBegin(gl.GL_QUADS);
				
				gl.glColor4f(1.0f, 1.0f, 1.0f, warningGlow);
				gl.glTexCoord2f(0.0f, 0.0f);
				gl.glVertex2f(80, 320);
				gl.glTexCoord2f(1.0f, 0.0f);
				gl.glVertex2f(180, 320);
				gl.glTexCoord2f(1.0f, 1.0f);
				gl.glVertex2f(180, 350);
				gl.glTexCoord2f(0.0f, 1.0f);
				gl.glVertex2f(80, 350);
				
				gl.glEnd();
			}
			
			gl.glDisable(gl.GL_TEXTURE_2D);
		
			glut.glutPostRedisplay();
            glut.glutSwapBuffers();

		}
		
		public void draw()
		{
			
			frameCount++;
			
			if (noDraw)
				return;
			else if (useGL)
				GLDraw();
			else if (gdiPaintOverride)
				this.Refresh();
			else
				gdiDraw();
			
		}
		
		public void gdiDraw()
		{
			
			float shakeX = 0.0f, shakeY = 0.0f;
			if (envShake > 0)
			{
				shakeX = (float)(rnd.NextDouble() - 0.5) * envShake;
				shakeY = (float)(rnd.NextDouble() - 0.5) * envShake;
			}
			
			g.Clear(Color.Black);
			
			g.TranslateTransform((300.0f - player.size.Width / 2.0f) - player.loc.X, (200.0f - player.size.Height / 2.0f) - player.loc.Y);
			if (envShake > 0)
				g.TranslateTransform(shakeX, shakeY);
			
			foreach (obj o in objs)
			{
				if (o.foreGround == false && !(noBGDraw && o.name == "BG"))
				{
					g.DrawImage(o.img.curImg(), new PointF[]{o.points[0], o.points[1], o.points[3]});
				}
			}
			g.ResetTransform();
			
			g.TranslateTransform((300.0f - player.size.Width / 2.0f) - player.loc.X, (200.0f - player.size.Height / 2.0f) - player.loc.Y);
			if (envShake > 0)
				g.TranslateTransform(shakeX, shakeY);
			
			foreach (body b in bodies)
			{
				Image temp = (Image)b.animgs[b.fullState()].curImg().Clone();
				
				if (b.vel.X < 0.0)
					b.flipImg = true;
				else if (b.vel.X > 0.0)
					b.flipImg = false;
				
				if (b.flipImg)
					temp.RotateFlip(RotateFlipType.RotateNoneFlipX);
				
				PointF imgLoc = new PointF(b.loc.X - (temp.Width - b.size.Width) / 2.0f, b.loc.Y - (temp.Height - b.size.Height) / 2.0f);
				g.DrawImage(temp, imgLoc);
			}
			
			if (debugDraws)
			{
				foreach (Boundry b in boundries)
				{
					if (b.type == 0)
						g.DrawLine(Pens.Yellow, b.p1, b.p2);
					else if (b.type == 1)
						g.DrawLine(Pens.Red, b.p1, b.p2);
					else if (b.type == 2)
						g.DrawLine(Pens.Green, b.p1, b.p2);
					else if (b.type == 3)
						g.DrawLine(Pens.Aqua, b.p1, b.p2);
					else if (b.type == 4)
						g.DrawLine(Pens.Purple, b.p1, b.p2);
				}
				if (player.onGround)
					this.Text = "On Ground";
				else
					this.Text = "!On Ground";
				this.Text += " [" + player.vel.X.ToString() + " " + player.vel.Y + "] at " + (frameCount / (fpsWatch.ElapsedMilliseconds / 1000 + 1)) + " fps";
			}
			
			g.ResetTransform();
			
			g.TranslateTransform((300.0f - player.size.Width / 2.0f) - player.loc.X, (200.0f - player.size.Height / 2.0f) - player.loc.Y);
			if (envShake > 0)
				g.TranslateTransform(shakeX, shakeY);
			
			foreach (obj o in objs)
			{
				if (o.foreGround)
				{
					g.DrawImage(o.img.curImg(), new PointF[]{o.points[0], o.points[1], o.points[3]});
				}
			}
			
			g.ResetTransform(); // I really have no idea why I kept so many of these
			
			g.TranslateTransform((300.0f - player.size.Width / 2.0f) - player.loc.X, (200.0f - player.size.Height / 2.0f) - player.loc.Y);
			if (envShake > 0)
				g.TranslateTransform(shakeX, shakeY);
						
			foreach (dust d in dusts)
				g.FillEllipse(new SolidBrush(d.colour), d.loc.X - 1.0f, d.loc.Y - 1.0f, 2.0f, 2.0f);
			foreach (fire f in fires)
				g.FillEllipse(new SolidBrush(f.colour), f.loc.X - 1.0f, f.loc.Y - 1.0f, 2.0f, 2.0f);
			foreach (fluid f in fluids)
				g.FillEllipse(new SolidBrush(f.colour), f.loc.X - 1.0f, f.loc.Y - 1.0f, 2.0f, 2.0f);
			
			g.ResetTransform();
			
			if (player.dead)
				g.FillRectangle(new SolidBrush(Color.FromArgb(100, 255, 0, 0)), 0, 0, 600, 400);
			if (brightness > 0)
			{
				g.FillRectangle(new SolidBrush(Color.FromArgb(brightness, 255, 255, 255)), 0, 0, 600, 400);
				brightness -= 5;
			}
			
			if (!gdiPaintOverride)
				this.Refresh();
		}
		
		public void figureSubState(body bdy, float offsetX, float offsetY)
		{
			// check for left/right slope
			bool leftCol = false, rightCol = false;
			if (!bdy.areas.ContainsKey(bdy.state))
			{
				foreach (Boundry b in boundries)
				{
					if (b.type == 0)
					{
						if (checkContact(b.p1, b.p2, new PointF(bdy.loc.X + bdy.legInset, bdy.loc.Y + bdy.size.Height + 2), new PointF(bdy.loc.X + bdy.legInset, bdy.loc.Y + bdy.size.Height - bdy.legLength))) // left
						{
							leftCol = true;
							if (rightCol)
								break;
						}
						if (checkContact(b.p1, b.p2, new PointF(bdy.loc.X + bdy.size.Width - bdy.legInset, bdy.loc.Y + bdy.size.Height + 2), new PointF(bdy.loc.X + bdy.size.Width - bdy.legInset, bdy.loc.Y + bdy.size.Height - bdy.legLength))) // right
						{
							rightCol = true;
							if (leftCol)
								break;
						}
					}
				}
			}
			else
			{
				RectangleF r = bdy.areas[bdy.state].rects[0];
				foreach (Boundry b in boundries)
				{
					if (b.type == 0)
					{
						if (checkContact(b.p1, b.p2, new PointF(bdy.loc.X + r.X + offsetX, bdy.loc.Y + r.Y + r.Height + offsetY - bdy.legLength), new PointF(bdy.loc.X + r.X + offsetX, bdy.loc.Y + r.Y + r.Height + offsetY + 2))) // left
						{
							leftCol = true;
							if (rightCol)
								break;
						}
						if (checkContact(b.p1, b.p2, new PointF(bdy.loc.X + r.X + r.Width + offsetX, bdy.loc.Y + r.Y + r.Height + offsetY - bdy.legLength), new PointF(bdy.loc.X + r.X + r.Width + offsetX, bdy.loc.Y + r.Y + r.Height + offsetY + 2))) // right
						{
							rightCol = true;
							if (leftCol)
								break;
						}
					}
				}
			}
			if (!leftCol && rightCol)
			{
				if (bdy.vel.X < 0.0 || (bdy.vel.X == 0 && bdy.flipImg))
					bdy.subState = "leftslope";
				else
					bdy.subState = "rightslope";
			}
			else if (leftCol && !rightCol)
			{
				if (bdy.vel.X < 0.0 || (bdy.vel.X == 0 && bdy.flipImg))
					bdy.subState = "rightslope";
				else
					bdy.subState = "leftslope";
			}
			else
				bdy.subState = "";
		}
		
		public bool ignores(PointF loc, SizeF size, float legLength, body bdy)
		{
			foreach (Boundry b in boundries)
			{
				if (b.type == 0 && !bdy.containsLine(b))
				{
					if (checkContact(b.p1, b.p2, loc, new PointF(loc.X, loc.Y + size.Height - legLength))) // left
						ignoreLines.Add(b);
					else if (checkContact(b.p1, b.p2, loc, new PointF(loc.X + size.Width, loc.Y))) // top
						ignoreLines.Add(b);
					else if (checkContact(b.p1, b.p2, new PointF(loc.X + size.Width / 2, loc.Y + size.Height), new PointF(loc.X, loc.Y + size.Height - legLength))) // bottom left
						ignoreLines.Add(b);
					else if (checkContact(b.p1, b.p2, new PointF(loc.X + size.Width / 2, loc.Y + size.Height), new PointF(loc.X + size.Width, loc.Y + size.Height - legLength))) // bottom left
						ignoreLines.Add(b);
					else if (checkContact(b.p1, b.p2, new PointF(loc.X + size.Width, loc.Y + size.Height - legLength), new PointF(loc.X + size.Width, loc.Y))) // right
						ignoreLines.Add(b);
					else if (checkContact(b.p1, b.p2, new PointF(loc.X, loc.Y), new PointF(loc.X + size.Width, loc.Y + size.Height - legLength))) // \
						ignoreLines.Add(b);
					else if (checkContact(b.p1, b.p2, new PointF(loc.X + size.Width, loc.Y), new PointF(loc.X, loc.Y + size.Height - legLength))) // /
						ignoreLines.Add(b);
				}
			}
			return false;
		}
		
		public bool bodyIgnores(body bdy, float offsetX, float offsetY)
		{
			ignoreLines.Clear();
			if (bdy.areas.ContainsKey(bdy.state))
			{
				foreach (Boundry b in boundries)
				{
					if (b.type == 0 && !bdy.containsLine(b))
					{
						foreach (RectangleF r in bdy.areas[bdy.state].rects)
						{
							// these are points for top/bottom left/right
							PointF tl = new PointF(bdy.loc.X + r.X + offsetX, bdy.loc.Y + r.Y + offsetY), tr = new PointF(bdy.loc.X + r.X + r.Width + offsetX, bdy.loc.Y + r.Y + offsetY), br = new PointF(bdy.loc.X + r.X + r.Width + offsetX, bdy.loc.Y + r.Y + r.Height + offsetY - bdy.legLength), bl = new PointF(bdy.loc.X + r.X + offsetX, bdy.loc.Y + r.Y + r.Height + offsetY - bdy.legLength), bc = new PointF(bdy.loc.X + r.X + offsetX + r.Width /2, bdy.loc.Y + r.Y + r.Height + offsetY);
							if (checkContact(b.p1, b.p2, tl, bl)) // left
								ignoreLines.Add(b);
							else if (checkContact(b.p1, b.p2, tl, tr)) // top
								ignoreLines.Add(b);
							else if (checkContact(b.p1, b.p2, bl, bc)) // bottom left
								ignoreLines.Add(b);
							else if (checkContact(b.p1, b.p2, bc, br)) // bottom right
								ignoreLines.Add(b);
							else if (checkContact(b.p1, b.p2, tr, br)) // right
								ignoreLines.Add(b);
							else if (checkContact(b.p1, b.p2, tl, br)) // \
								ignoreLines.Add(b);
							else if (checkContact(b.p1, b.p2, tr, bl)) // /
								ignoreLines.Add(b);
						}
					}
				}
				return false;
			}
			else
				return ignores(new PointF(bdy.loc.X + offsetX, bdy.loc.Y + offsetY), bdy.size, bdy.legLength, bdy);

		}
		
		public bool collides(PointF loc, SizeF size, float legLength, body bdy)
		{
			foreach (Boundry b in boundries)
			{
				if (b.type == 0 && !bdy.containsLine(b) && !ignoreLines.Contains(b))
				{
					if (checkContact(b.p1, b.p2, loc, new PointF(loc.X, loc.Y + size.Height - legLength))) // left
						return true;
					else if (checkContact(b.p1, b.p2, loc, new PointF(loc.X + size.Width, loc.Y))) // top
						return true;
					else if (checkContact(b.p1, b.p2, new PointF(loc.X + size.Width / 2, loc.Y + size.Height), new PointF(loc.X, loc.Y + size.Height - legLength))) // bottom left
						return true;
					else if (checkContact(b.p1, b.p2, new PointF(loc.X + size.Width / 2, loc.Y + size.Height), new PointF(loc.X + size.Width, loc.Y + size.Height - legLength))) // bottom left
						return true;
					else if (checkContact(b.p1, b.p2, new PointF(loc.X + size.Width, loc.Y + size.Height - legLength), new PointF(loc.X + size.Width, loc.Y))) // right
						return true;
					else if (checkContact(b.p1, b.p2, new PointF(loc.X, loc.Y), new PointF(loc.X + size.Width, loc.Y + size.Height - legLength))) // \
						return true;
					else if (checkContact(b.p1, b.p2, new PointF(loc.X + size.Width, loc.Y), new PointF(loc.X, loc.Y + size.Height - legLength))) // /
						return true;
				}
			}
			return false;
		}
		
		public bool bodyCollides(body bdy, float offsetX, float offsetY)
		{
			if (bdy.areas.ContainsKey(bdy.state))
			{
				foreach (Boundry b in boundries)
				{
					if (b.type == 0 && !bdy.containsLine(b) && !ignoreLines.Contains(b))
					{
						foreach (RectangleF r in bdy.areas[bdy.state].rects)
						{
							// these are points for top/bottom left/right
							PointF tl = new PointF(bdy.loc.X + r.X + offsetX, bdy.loc.Y + r.Y + offsetY), tr = new PointF(bdy.loc.X + r.X + r.Width + offsetX, bdy.loc.Y + r.Y + offsetY), br = new PointF(bdy.loc.X + r.X + r.Width + offsetX, bdy.loc.Y + r.Y + r.Height + offsetY - bdy.legLength), bl = new PointF(bdy.loc.X + r.X + offsetX, bdy.loc.Y + r.Y + r.Height + offsetY - bdy.legLength), bc = new PointF(bdy.loc.X + r.X + offsetX + r.Width /2, bdy.loc.Y + r.Y + r.Height + offsetY);
							if (checkContact(b.p1, b.p2, tl, bl)) // left
								return true;
							else if (checkContact(b.p1, b.p2, tl, tr)) // top
								return true;
							else if (checkContact(b.p1, b.p2, bl, bc)) // bottom left
								return true;
							else if (checkContact(b.p1, b.p2, bc, br)) // bottom right
								return true;
							else if (checkContact(b.p1, b.p2, tr, br)) // right
								return true;
							else if (checkContact(b.p1, b.p2, tl, br)) // \
								return true;
							else if (checkContact(b.p1, b.p2, tr, bl)) // /
								return true;
						}
					}
				}
				return false;
			}
			else
				return collides(new PointF(bdy.loc.X + offsetX, bdy.loc.Y + offsetY), bdy.size, bdy.legLength, bdy);

		}
		
		public int other(PointF loc, SizeF size, bool dieOnly, body bdy)
		{
			foreach (Boundry b in boundries)
			{
				if ((b.type == 1 || (!dieOnly && b.type == 2)) && !bdy.containsLine(b))
				{
					if (checkContact(b.p1, b.p2, loc, new PointF(loc.X, loc.Y + size.Height))) // left
						return b.type;
					else if (checkContact(b.p1, b.p2, loc, new PointF(loc.X + size.Width, loc.Y))) // top
						return b.type;
					else if (checkContact(b.p1, b.p2, new PointF(loc.X + size.Width, loc.Y + size.Height), new PointF(loc.X, loc.Y + size.Height))) // bottom
						return b.type;
					else if (checkContact(b.p1, b.p2, new PointF(loc.X + size.Width, loc.Y + size.Height), new PointF(loc.X + size.Width, loc.Y))) // right
						return b.type;
					else if (checkContact(b.p1, b.p2, new PointF(loc.X, loc.Y), new PointF(loc.X + size.Width, loc.Y + size.Height))) // \
						return b.type;
					else if (checkContact(b.p1, b.p2, new PointF(loc.X + size.Width, loc.Y), new PointF(loc.X, loc.Y + size.Height))) // /
						return b.type;
				}
			}
			return -1;
		}
		
		public int bodyOther(body bdy, float offsetX, float offsetY, bool dieOnly)
		{
			if (bdy.areas.ContainsKey(bdy.state))
			{
				foreach (Boundry b in boundries)
				{
					if ((b.type == 1 || (!dieOnly && b.type == 2)) && !bdy.containsLine(b))
					{
						foreach (RectangleF r in bdy.areas[bdy.state].rects)
						{
							// these are points for top/bottom left/right
							PointF tl = new PointF(bdy.loc.X + r.X + offsetX, bdy.loc.Y + r.Y + offsetY), tr = new PointF(bdy.loc.X + r.X + r.Width + offsetX, bdy.loc.Y + r.Y + offsetY), br = new PointF(bdy.loc.X + r.X + r.Width + offsetX, bdy.loc.Y + r.Y + r.Height + offsetY), bl = new PointF(bdy.loc.X + r.X + offsetX, bdy.loc.Y + r.Y + r.Height + offsetY);
							if (checkContact(b.p1, b.p2, tl, bl)) // left
								return b.type;
							else if (checkContact(b.p1, b.p2, tl, tr)) // top
								return b.type;
							else if (checkContact(b.p1, b.p2, bl, br)) // bottom
								return b.type;
							else if (checkContact(b.p1, b.p2, tr, br)) // right
								return b.type;
							else if (checkContact(b.p1, b.p2, tl, br)) // \
								return b.type;
							else if (checkContact(b.p1, b.p2, tr, bl)) // /
								return b.type;
						}
					}
				}
				return -1;
			}
			else
				return other(new PointF(bdy.loc.X + offsetX, bdy.loc.Y + offsetY), bdy.size, dieOnly, bdy);

		}
		
		public void trigger(PointF loc, SizeF size, bool invoked, body bdy)
		{
			List<string> execs = new List<string>();
			Boundry b;
			for (int i = boundries.Count - 1; i > 0; i--)
			{
				b = boundries[i];
				if (b.trigger != "" && b.invoked == invoked && !bdy.containsLine(b))
				{
					if (checkContact(b.p1, b.p2, loc, new PointF(loc.X, loc.Y + size.Height))) // left
						execs.Add(b.trigger);
					else if (checkContact(b.p1, b.p2, loc, new PointF(loc.X + size.Width, loc.Y))) // top
						execs.Add(b.trigger);
					else if (checkContact(b.p1, b.p2, new PointF(loc.X + size.Width, loc.Y + size.Height), new PointF(loc.X, loc.Y + size.Height))) // bottom
						execs.Add(b.trigger);
					else if (checkContact(b.p1, b.p2, new PointF(loc.X + size.Width, loc.Y + size.Height), new PointF(loc.X + size.Width, loc.Y))) // right
						execs.Add(b.trigger);
					else if (checkContact(b.p1, b.p2, new PointF(loc.X, loc.Y), new PointF(loc.X + size.Width, loc.Y + size.Height))) // \
						execs.Add(b.trigger);
					else if (checkContact(b.p1, b.p2, new PointF(loc.X + size.Width, loc.Y), new PointF(loc.X, loc.Y + size.Height))) // /
						execs.Add(b.trigger);
				}
			}
			for (int i = 0; i < execs.Count; i++)
				exec(execs[i]);
		}
		
		public void bodyTrigger(body bdy, float offsetX, float offsetY, bool invoked)
		{
			if (bdy.areas.ContainsKey(bdy.state))
			{
				List<string> execs = new List<string>();
				Boundry b;
				for (int i = boundries.Count - 1; i > 0; i--)
				{
					b = boundries[i];
					if (b.trigger != "" && b.invoked == invoked && !bdy.containsLine(b))
					{
						foreach (RectangleF r in bdy.areas[bdy.state].rects)
						{
							// these are points for top/bottom left/right
							PointF tl = new PointF(bdy.loc.X + r.X + offsetX, bdy.loc.Y + r.Y + offsetY), tr = new PointF(bdy.loc.X + r.X + r.Width + offsetX, bdy.loc.Y + r.Y + offsetY), br = new PointF(bdy.loc.X + r.X + r.Width + offsetX, bdy.loc.Y + r.Y + r.Height + offsetY), bl = new PointF(bdy.loc.X + r.X + offsetX, bdy.loc.Y + r.Y + r.Height + offsetY);
							if (checkContact(b.p1, b.p2, tl, bl)) // left
								execs.Add(b.trigger);
							else if (checkContact(b.p1, b.p2, tl, tr)) // top
								execs.Add(b.trigger);
							else if (checkContact(b.p1, b.p2, bl, br)) // bottom
								execs.Add(b.trigger);
							else if (checkContact(b.p1, b.p2, tr, br)) // right
								execs.Add(b.trigger);
							else if (checkContact(b.p1, b.p2, tl, br)) // \
								execs.Add(b.trigger);
							else if (checkContact(b.p1, b.p2, tr, bl)) // /
								execs.Add(b.trigger);
						}
					}
				}
				for (int i = 0; i < execs.Count; i++)
					exec(execs[i]);
			}
			else
				trigger(new PointF(bdy.loc.X + offsetX, bdy.loc.Y + offsetY), bdy.size, invoked, bdy);

		}
		
		public float planar(PointF loc, SizeF size, body bdy)
		{
			foreach (Boundry b in boundries)
			{
				if (b.type == 3 && !bdy.containsLine(b))
				{
					if (checkContact(b.p1, b.p2, loc, new PointF(loc.X, loc.Y + size.Height))) // left
						return (b.angle);
					else if (checkContact(b.p1, b.p2, loc, new PointF(loc.X + size.Width, loc.Y))) // top
						return (b.angle);
					else if (checkContact(b.p1, b.p2, new PointF(loc.X + size.Width, loc.Y + size.Height), new PointF(loc.X, loc.Y + size.Height))) // bottom
						return (b.angle);
					else if (checkContact(b.p1, b.p2, new PointF(loc.X + size.Width, loc.Y + size.Height), new PointF(loc.X + size.Width, loc.Y))) // right
						return (b.angle);
					else if (checkContact(b.p1, b.p2, new PointF(loc.X, loc.Y), new PointF(loc.X + size.Width, loc.Y + size.Height))) // \
						return (b.angle);
					else if (checkContact(b.p1, b.p2, new PointF(loc.X + size.Width, loc.Y), new PointF(loc.X, loc.Y + size.Height))) // /
						return (b.angle);
				}
			}
			return planeAngle;
		}
		
		public float bodyPlanar(body bdy, float offsetX, float offsetY)
		{
			if (bdy.areas.ContainsKey(bdy.state))
			{
				foreach (Boundry b in boundries)
				{
					if (b.type == 3 && !bdy.containsLine(b) &&! ignoreLines.Contains(b))
					{
						foreach (RectangleF r in bdy.areas[bdy.state].rects)
						{
							// these are points for top/bottom left/right
							PointF tl = new PointF(bdy.loc.X + r.X + offsetX, bdy.loc.Y + r.Y + offsetY), tr = new PointF(bdy.loc.X + r.X + r.Width + offsetX, bdy.loc.Y + r.Y + offsetY), br = new PointF(bdy.loc.X + r.X + r.Width + offsetX, bdy.loc.Y + r.Y + r.Height + offsetY), bl = new PointF(bdy.loc.X + r.X + offsetX, bdy.loc.Y + r.Y + r.Height + offsetY);
							if (checkContact(b.p1, b.p2, tl, bl)) // left
								return (b.angle);
							else if (checkContact(b.p1, b.p2, tl, tr)) // top
								return (b.angle);
							else if (checkContact(b.p1, b.p2, bl, br)) // bottom
								return (b.angle);
							else if (checkContact(b.p1, b.p2, tr, br)) // right
								return (b.angle);
							else if (checkContact(b.p1, b.p2, tl, br)) // \
								return (b.angle);
							else if (checkContact(b.p1, b.p2, tr, bl)) // /
								return (b.angle);
						}
					}
				}
				return planeAngle;
			}
			else
				return planar(new PointF(bdy.loc.X + offsetX, bdy.loc.Y + offsetY), bdy.size, bdy);

		}
		
		public double getAngle(PointF a, PointF b)
        {
            if (a.X == b.X)
            {
                if (a.Y < b.Y)
                    return 90;
                else
                    return 270;
            }
            else if (a.Y == b.Y)
            {
                if (a.X < b.X)
                    return 0;
                else
                    return 180;
            }
            double output = (double)(Math.Atan((b.Y - a.Y) / (double)(b.X - a.X)) / Math.PI * 180.0);
            if (a.X >= b.X)
                output += 180;
            if (output > 360)
                output -= 360;
            return output;
		}
		
        public bool checkContact(PointF a1, PointF a2, PointF b1, PointF b2) 
        { 
                 
        	colls++;
        	
			float aM, bM, aC, bC; 
			float x = 0; 
			float y = 0; 
			
			if (a1.X == a2.X && b1.X == b2.X)
			{
				if (a1.X == b1.X)
				{
					if (((Math.Sign(a1.Y - b1.Y) != Math.Sign(a2.Y - b1.Y)) || (Math.Sign(a1.Y - b2.Y) != Math.Sign(a2.Y - b2.Y))))
					    return true;
					return false;
				}
			}
			else if (a1.X == a2.X)
			{
				bM = (b1.Y - b2.Y) / (float)(b1.X - b2.X); 
				bC = b1.Y - bM * (float)b1.X;
				
				x = a1.X;
				y = bM * x + bC;
			}
			else if (b1.X == b2.X)
			{
				aM = (a1.Y - a2.Y) / (float)(a1.X - a2.X); 
				aC = a1.Y - aM * (float)a1.X;
				
				x = b1.X;
				y = aM * x + aC;
			}
			else
			{
				aM = (a1.Y - a2.Y) / (float)(a1.X - a2.X); 
				aC = a1.Y - aM * (float)a1.X; 
				bM = (b1.Y - b2.Y) / (float)(b1.X - b2.X); 
				bC = b1.Y - bM * (float)b1.X; 
				
				x = (bC - aC) / (float)(aM - bM); 
				y = (bM * aC - aM * bC) / (float)(bM - aM); 
			}
			
			if (((a1.X >= x && a2.X <= x) || (a1.X <= x && a2.X >= x)) && ((a1.Y <= y && a2.Y >= y) || (a1.Y >= y && a2.Y <= y)) && ((b1.X >= x && b2.X <= x) || (b1.X <= x && b2.X >= x)) && ((b1.Y <= y && b2.Y >= y) || (b1.Y >= y && b2.Y <= y))) 
				return true; 
			
			return false; 
                 
        }
        
        public void setBodyState(body b, string state)
        {
        	if (state == b.state || (b.dead && state != "dead") || (b.win && state != "win"))
        		return;
        	if (sound)
        	{
        		if (b.sounds.ContainsKey(b.state))
        			b.sounds[b.state].Stop();
        		if (b.sounds.ContainsKey(state))
        			b.sounds[state].PlayLooping();
        		if (b.sounds.ContainsKey("-" + b.state))
        			b.sounds["-" + b.state].Play();
        		if (b.sounds.ContainsKey("+" + state))
        			b.sounds["+" + state].Play();
        	}
	        b.state = state;
	        b.animgs[state].runTime = 0;
        }
		
		void Timer1Tick(object sender, EventArgs e)
		{
			
			tick();
			
		}
		
		public void tick() // general stuff with player go integrated
		{
			
			if ((!warning && !player.dead && envShake <= 2.0f && !player.burning) || warningGlow <= 0.05f)
				warningGlow = 1.0f;
			else
				warningGlow -= 0.04f;
			if (player.vel.Y > 45.5)
			    warning = true;
			else
			   	warning = false;
			
			// loops
			offsetLoop();
			dustLoop();
			fireLoop();
			fluidLoop();
			scriptLoop();
			bodyLoop();
			
			bodyIgnores(player, 0, 0);
			
			if (player.burning)
			{
				if (player.areas.ContainsKey(player.state))
				{
					foreach (RectangleF r in  player.areas[player.state].rects)
					{
						for (int i = 0; i < 10; i++)
							fires.Add(new fire(new PointF(player.loc.X + r.X + (float)rnd.NextDouble() * r.Width, player.loc.Y + r.Y + (float)rnd.NextDouble() * r.Height), new PointF((float)rnd.NextDouble() * 6.0f - 3.0f, (float)rnd.NextDouble() * 3.0f)));
					}
				}
				else
				{
					for (int i = 0; i < 10; i++)
						fires.Add(new fire(new PointF(player.loc.X + (float)rnd.NextDouble() * player.size.Width, player.loc.Y + (float)rnd.NextDouble() * player.size.Height), new PointF((float)rnd.NextDouble() * 6.0f - 3.0f, (float)rnd.NextDouble() * 3.0f)));
				}
			}
			else if (player.burned != "" )
			{
				foreach (fire f in fires)
				{
					if (f.loc.X > player.loc.X && f.loc.X < player.loc.X + player.size.Width && f.loc.Y > player.loc.Y && f.loc.Y < player.loc.Y + player.size.Height)
					{
						exec(player.burned);
						break;
					}
				}
			}
			
			if (envShake > 0.0f)
				envShake -= 0.2f;
			
			curBody = player.name;
			
			player.vel.X -= player.vel.X * envDrag * player.area;
			player.vel.Y -= player.vel.Y * envDrag * player.area;
			
			// fun stuff
			if (player.animgs["win"].runTime == player.animgs["win"].maxRunTime - 1)
			{
				fluids.Clear();
				fires.Clear();
				dusts.Clear();
				loadLevel(curLevel);
				return;
			}
			if (player.animgs["dead"].runTime == player.animgs["dead"].maxRunTime - 1)
			{
				if (player.killed != "")
					exec(player.killed);
				player.killed = "";
				loadLevel(curLevel);
				return;
			}
			
			if (player.dead || player.state == "dead")
			{
				if (bodyCollides(player, 0, 0))
				{
					incAll();
					draw();
					return;
				}
			}
			
			timer1.Stop();
			
			bool yFixs = false;
						
			if (player.win)
				setBodyState(player, "win");
			incAll();
			draw();
			if (!player.dead)
			{
				if (keysDown[(int)Keys.Right] || keysDown[(int)Keys.D] || keysDown[(int)Keys.L])
				{
					if (player.vel.X < player.maxSpeed)
						player.vel.X += player.accel;
					if (player.onGround)
						setBodyState(player, "run");
				}
				else if (keysDown[(int)Keys.Left] || keysDown[(int)Keys.A] || keysDown[(int)Keys.J])
				{
					if (player.vel.X > -player.maxSpeed)
						player.vel.X -= player.accel;
					if (player.onGround)
						setBodyState(player, "run");
				}
				else
				{
					if (player.onGround)
					{
						setBodyState(player, "still");
						player.vel.X -= (float)Math.Sign(player.vel.X) / 2.0f;
					}
				}
				
				if (player.onGround && (keysDown[(int)Keys.Up] || keysDown[(int)Keys.W] || keysDown[(int)Keys.I]))
				{
					player.vel.Y = -player.jump / player.mass;
					player.onGround = false;
				}
			}
			
			if (Math.Abs(player.vel.X) < 0.3f)
				player.vel.X = 0.0f;
//			else
//				player.vel.X -= Math.Sign(player.vel.X) / 4.0f;
			
			if (bodyCollides(player, player.vel.X, 0))
			{
				for (float i = 0.5f; i <  Math.Abs(player.vel.X); i += 0.5f)
				{
					if (!bodyCollides(player, player.vel.X, -i))
					{
						yFixs = true;
						player.loc.Y -= i;
						player.vel.Y -= i;
						player.onGround = true;
						break;
					}
				}
				
				if (!yFixs)
				{
					while (bodyCollides(player, player.vel.X, 0))
					{
						player.vel.X -= Math.Sign(player.vel.X) / 2.0f;
						if (Math.Abs(player.vel.X) < 0.01)
							player.vel.X = -1 * Math.Sign(player.vel.X);
					}
					player.loc.X += player.vel.X;
					player.vel.X = 0.0f;
				}
			}
			
			if (bodyCollides(player, 0, player.vel.Y))
			{
				float velY = player.vel.Y;
				bool flat = false;
				if (velY > player.deathSpeed)
					flat = true;
				while (bodyCollides(player, 0, player.vel.Y))
				{
					player.vel.Y -= Math.Sign(player.vel.Y) / 2.0f;
				}
				player.loc.Y += player.vel.Y;
				player.vel.Y = 0.0f;
				addDusts(new PointF(player.loc.X  + (player.size.Width / 2.0f), player.loc.Y + player.size.Height), (int)velY * 40, velY, Color.FromArgb(25, 140, 140, 140));
				if (flat)
				{
					addDusts(new PointF(player.loc.X  + (player.size.Width / 2.0f), player.loc.Y + player.size.Height), (int)velY * 40, 20.0f, Color.FromArgb(255, 200, 50, 50));
					die(player);;
				}
			}
			
			if (!bodyCollides(player, 0, 0.5f) && !yFixs)
			{
				player.vel.Y += envGravity;
				player.onGround = false;
				setBodyState(player, "fall");
			}
			else
			{
				player.onGround = true;
			}
			
			if (bodyCollides(player, Math.Sign(player.vel.X) * 0.5f, 0))
			{
				player.vel.X = 0.0f;
			}
			
			player.loc.X += player.vel.X;
			player.loc.Y += player.vel.Y;
			
			if (bodyCollides(player, 0, 0))
		    {
				player.loc.X -= player.vel.X;
				player.loc.Y -= player.vel.Y;
				player.vel.X = 0;
				player.vel.Y = 0;
		    }
			
			int cType = bodyOther(player, 0, 0, false);
			if (cType == 1)
				die(player);
			else if (cType == 2 && !player.dead)
				win();
			
			float newAngle = bodyPlanar(player, 0, 0);
			if (newAngle != planeAngle)
			{
				rotatePlane(newAngle - planeAngle, new PointF(player.loc.X + player.size.Width / 2.0f, player.loc.Y + player.size.Height / 2.0f));
			}
			
			bodyTrigger(player, 0, 0, false);
			figureSubState(player, 0, 0);
			
			if (player.dead)
				setBodyState(player, "dead");
			else if (player.win)
				setBodyState(player, "win");
			
			timer1.Start();
		}
		
		public void bodyGo(body b)
		{
			
			bodyIgnores(b, 0, 0);
			
			curBody = b.name;
			
			if (b.burning)
			{
				if (b.areas.ContainsKey(b.state))
				{
					foreach (RectangleF r in  b.areas[b.state].rects)
					{
						for (int i = 0; i < 10; i++)
							fires.Add(new fire(new PointF(b.loc.X + r.X + (float)rnd.NextDouble() * r.Width, b.loc.Y + r.Y + (float)rnd.NextDouble() * r.Height), new PointF((float)rnd.NextDouble() * 6.0f - 3.0f, (float)rnd.NextDouble() * 3.0f)));
					}
				}
				else
				{
					for (int i = 0; i < 10; i++)
						fires.Add(new fire(new PointF(b.loc.X + (float)rnd.NextDouble() * b.size.Width, b.loc.Y + (float)rnd.NextDouble() * b.size.Height), new PointF((float)rnd.NextDouble() * 6.0f - 3.0f, (float)rnd.NextDouble() * 3.0f)));
				}
			}
			else if (b.burned != "" )
			{
				foreach (fire f in fires)
				{
					if (f.loc.X > b.loc.X && f.loc.X < b.loc.X + b.size.Width && f.loc.Y > b.loc.Y && f.loc.Y < b.loc.Y + b.size.Height)
					{
						exec(b.burned);
						break;
					}
				}
			}
			
			b.vel.X -= b.vel.X * envDrag * b.area;
			b.vel.Y -= b.vel.Y * envDrag * b.area;
			
			if (b.animgs["dead"].runTime == b.animgs["dead"].maxRunTime - 1)
			{
				if (b.killed != "")
				{
					exec(b.killed);
					b.killed = "";
				}
			}
			
			if (bodyCollides(b, 0, 0))
			{
				// this may need re-thinking... matter transmit to start/rnd_location?
				bodies.Remove(b);
				return;
			}
			
			bool yFixs = false;
			
			if (!b.dead)
			{
				if (b.goRight)
				{
					if (b.vel.X < b.maxSpeed)
						b.vel.X += b.accel;
					if (b.onGround)
						setBodyState(b, "run");
				}
				else if (b.goLeft)
				{
					if (b.vel.X > -b.maxSpeed)
						b.vel.X -= b.accel;
					if (b.onGround)
						setBodyState(b, "run");
				}
				else
				{
					if (b.onGround)
					{
						setBodyState(b, "still");
						b.vel.X -= (float)Math.Sign(b.vel.X) / 2.0f;
					}
				}
				
				if (b.goUp && b.onGround)
				{
					b.vel.Y = -b.jump / b.mass;
					b.onGround = false;
				}
			}
			
			if (Math.Abs(b.vel.X) < 0.3f)
				b.vel.X = 0.0f;
			
			if (bodyCollides(b, b.vel.X, 0))
			{
				for (float i = 0.5f; i <  Math.Abs(b.vel.X); i += 0.5f)
				{
					if (!bodyCollides(b, b.vel.X, -i))
					{
						yFixs = true;
						b.loc.Y -= i;
						b.vel.Y -= i;
						b.onGround = true;
						break;
					}
				}
				
				if (!yFixs)
				{
					while (bodyCollides(b, b.vel.X, 0))
					{
						b.vel.X -= Math.Sign(b.vel.X) / 2.0f;
					}
					b.loc.X += b.vel.X;
					b.vel.X = 0.0f;
				}
			}
			
			if (bodyCollides(b, 0, b.vel.Y))
			{
				float velY = b.vel.Y;
				bool flat = false;
				if (velY > b.deathSpeed)
					flat = true;
				while (bodyCollides(b, 0, b.vel.Y))
				{
					b.vel.Y -= Math.Sign(b.vel.Y) / 2.0f;
				}
				b.loc.Y += b.vel.Y;
				b.vel.Y = 0.0f;
				addDusts(new PointF(b.loc.X  + (b.size.Width / 2.0f), b.loc.Y + b.size.Height), (int)velY * 40, velY, Color.FromArgb(25, 140, 140, 140));
				if (flat)
				{
					addDusts(new PointF(b.loc.X  + (b.size.Width / 2.0f), b.loc.Y + b.size.Height), (int)velY * 40, 20.0f, Color.FromArgb(255, 200, 50, 50));
					die(b);;
				}
			}
			
			if (!bodyCollides(b, 0, 0.5f) && !yFixs)
			{
				b.vel.Y += envGravity;
				b.onGround = false;
				setBodyState(b, "fall");
			}
			else
			{
				b.onGround = true;
			}
			
			if (bodyCollides(b, Math.Sign(b.vel.X) * 0.5f, 0))
			{
				b.vel.X = 0.0f;
			}
			
			b.loc.X += b.vel.X;
			b.loc.Y += b.vel.Y;
			
			if (bodyCollides(b, 0, 0))
		    {
				b.loc.X -= b.vel.X;
				b.loc.Y -= b.vel.Y;
				b.vel.X = 0;
				b.vel.Y = 0;
				this.BackColor = Color.Orange;
		    }
			
			if (b.canDie)
			{
				int cType = bodyOther(b, 0, 0, true);
				if (cType == 1)
					die(b);;
			}
			
			bodyTrigger(b, 0, 0, false);
			figureSubState(b, 0, 0);
			
			if (b.dead)
				setBodyState(b, "dead");
			
			this.Text = b.state;
			
		}
		
		public void addDusts(PointF loc, int num, float speed, Color colour)
		{
			for (int i = 0; i < num; i++)
			{
				dusts.Add(new dust(new PointF(loc.X + ((float)rnd.NextDouble() * player.size.Width  - (player.size.Width / 2.0f)), loc.Y), new PointF((((float)(rnd.NextDouble()) - 0.5f) * speed) + player.vel.X, (((float)(rnd.NextDouble()) - 0.8f) * speed)), colour));
			}
		}
		
		public void addSparks(PointF loc, int num, float speed, Color colour)
		{
			for (int i = 0; i < num; i++)
			{
				dusts.Add(new dust(new PointF(loc.X, loc.Y), new PointF((((float)(rnd.NextDouble()) - 0.5f) * speed), (((float)(rnd.NextDouble()) - 0.5f) * speed)), colour));
			}
		}
		
		public void offsetLoop()
		{
			foreach (body b in bodies)
				b.offsetLines();
		}
		
		public void bodyLoop()
		{
			for (int i = bodies.Count - 1; i >= 0; i--)
			{
				if (bodies[i].name != player.name && !bodies[i].disabled)
				{
					bodyGo(bodies[i]);
				}
			}
		}
		
		public void dustLoop()
		{
			dust d;
			for (int i = dusts.Count - 1; i > 0; i--)
			{
				if (rnd.Next(10) == 1)
					dusts.RemoveAt(i);
				else
				{
					d = dusts[i];
					d.loc.X += d.vel.X *= 0.9f;
					d.loc.Y += d.vel.Y *= 0.9f;
				}
			}
		}
		
		public void fireLoop()
		{
			fire f;
			bool died;
			for (int i = fires.Count - 1; i >= 0; i--)
			{
				if (rnd.Next(20) == 1)
					fires.RemoveAt(i);
				else
				{
					died = false;
					f = fires[i];
					if (f.colour.R > 150)
						f.colour = Color.FromArgb(f.colour.R - 1, f.colour.G, f.colour.B + 1);
					else
					{
						fires.RemoveAt(i);
						continue;
					}
					if (f.vel.Y > -1.0f)
						f.vel.Y -= 0.3f;
					if (f.loc.X > f.xAim)
						f.loc.X -= 1.0f;
					else if (f.loc.X < f.xAim)
						f.loc.X += 1.0f;
					f.vel.X *= 0.9f;
					f.vel.Y -= 0.1f;
					
					foreach (Boundry b in boundries)
					{
						if (b.type == 0)
						{
							if (checkContact(b.p1, b.p2, f.loc, new PointF(f.loc.X + f.vel.X, f.loc.Y + f.vel.Y)))
							{
								fires.RemoveAt(i);
								died = true;
								break;
							}
						}
					}
					
					if (!died)
					{
						f.loc.X += f.vel.X;
						f.loc.Y += f.vel.Y;
					}
				}
			}
		}
		
		public void fluidLoop()
		{
			fluid f;
			bool died;
			for (int i = fluids.Count - 1; i >= 0; i--)
			{
				died = false;
				f = fluids[i];
				
				if (f.vel.Y > 2000)
				{
					fluids.RemoveAt(i);
					died = true;
					continue;
				}
				
				if (f.flamable && rnd.Next(3) == 1)
				{
					foreach (fire r in fires)
					{
						if (Math.Abs(r.loc.X - f.loc.X) + Math.Abs(r.loc.Y - f.loc.Y) < 4)
						{
							fires.Add(new fire(f.loc, new PointF(f.vel.X / 2.0f, f.vel.Y / 2.0f)));
							fluids.RemoveAt(i);
							died = true;
							break;
						}
					}
					if (died)
						continue;
				}
				
				
				f.vel.X *= 0.9f;
				f.vel.Y += envGravity - f.vel.Y * envDrag;
				
				foreach (Boundry b in boundries)
				{
					if (b.type == 0)
					{
						if (checkContact(b.p1, b.p2, f.loc, new PointF(f.loc.X + f.vel.X, f.loc.Y + f.vel.Y)))
						{
							fluids.RemoveAt(i);
							died = true;
							break;
						}
					}
				}
				
				if (!died)
				{
					f.loc.X += f.vel.X;
					f.loc.Y += f.vel.Y;
				}
			}
		}
		
		public void scriptLoop()
		{
			foreach (script s in scripts)
			{
				exec(s.curLine());
				s.inc();
			}
		}
		
		public void win()
		{
			curLevel = nextLevel;
			player.win = true;
			setBodyState(player, "win");
		}
			
		public void die(body b)
		{
			if (!b.canDie)
				return;
			b.dead = true;
			b.win = false;
			setBodyState(b, "dead");
		}
		
		public void revive(body b)
		{
			b.dead = false;
			setBodyState(b, "still");
		}
		
		void MainFormLoad(object sender, EventArgs e)
		{
			loadLevel(curLevel);
			timer1.Start();
			this.Hide();
		}
		
		void MainFormKeyDown(object sender, KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Return)
			{
				timer1.Enabled = !timer1.Enabled;
				showMenu = !showMenu;
				if (showMenu)
					draw();
				return;
			}
			if (showMenu)
				return;
			this.Text = e.KeyCode.ToString();
			if (keyMaps.ContainsKey(e.KeyCode.ToString()))
			{
				try {
				exec(keyMaps[e.KeyCode.ToString()]);
				}
				catch (Exception ex)
				{
					con.addHistory(ex.Message);
				}
			}
			if (e.KeyCode == Keys.Space)
			{
				string oldBody = curBody;
				curBody = player.name;
				bodyTrigger(player, 0, 0, true);
				curBody = oldBody;
			}
			if (e.KeyCode == Keys.Escape)
			{
				if (con.IsDisposed)
					con = new console(this);
				con.Show();
			}
			else if (canRotate)
			{
				if (e.KeyCode == Keys.Q || keysDown[(int)Keys.U])
					rotatePlane(-90, new PointF(player.loc.X + player.size.Width / 2.0f, player.loc.Y + player.size.Height / 2.0f));
				else if (e.KeyCode == Keys.E || keysDown[(int)Keys.O])
					rotatePlane(90, new PointF(player.loc.X + player.size.Width / 2.0f, player.loc.Y + player.size.Height / 2.0f));
			}
			if (editorMode)
			{
				if (e.KeyCode == Keys.D0)
					boundries[boundries.Count - 1].type = 0;
				if (e.KeyCode == Keys.D1)
					boundries[boundries.Count - 1].type = 1;
				if (e.KeyCode == Keys.D2)
					boundries[boundries.Count - 1].type = 2;
				if (e.KeyCode == Keys.D3)
					boundries[boundries.Count - 1].type = 3;
				if (e.KeyCode == Keys.D4)
					boundries[boundries.Count - 1].type = 4;
			}
			
			keysDown[(int)e.KeyCode] = true;
		}
		
		void MainFormKeyUp(object sender, KeyEventArgs e)
		{
			keysDown[(int)e.KeyCode] = false;
		}
		
		void MainFormFormClosing(object sender, FormClosingEventArgs e)
		{
			foreach (string k in player.animgs.Keys)
				player.animgs[k].empty();
			player.animgs.Clear();
		}
		
		void MainFormMouseClick(object sender, MouseEventArgs e)
		{
			if (editorMode)
			{
				if (mouses == 0)
				{
					Console.Beep(2000, 100);
					mouse = new PointF(e.X + player.loc.X - 300 + player.size.Width / 2.0f, e.Y + player.loc.Y - 200 + player.size.Height / 2.0f);
					mouses = 1;
				}
				else
				{
					Console.Beep(5000, 100);
					boundries.Add(new Boundry(4, mouse, new PointF(e.X + player.loc.X - 300 + player.size.Width / 2.0f, e.Y + player.loc.Y - 200 + player.size.Height / 2.0f)));
					mouses = 0;
				}
			}
		}
		
		public void keyPressFunc(int key, int x, int y)
		{
			
		}
		
		public void keyReleseFunc(int key, int x, int y)
		{
			
		}
		
		public void mouseFunc(int button, int state, int x, int y)
		{
			if (showMenu)
			{
				if (button == glut.GLUT_LEFT_BUTTON && state == glut.GLUT_DOWN)
				{
					
				}
			}
		}
		
		void MainFormPaint(object sender, PaintEventArgs e)
		{
			if (!useGL && gdiPaintOverride)
			{
				g = e.Graphics;
				gdiDraw();
			}
		}
	}
	
	public static class funcs
	{
		
		public static bool use512textureLimit = false;
		public static bool use16bitTextureLimit = false;
		
		public static uint[] renderGLText(string text, Font font, Color colour)
		{
			Size size = TextRenderer.MeasureText(text, font);
			Bitmap img = new Bitmap(size.Width, size.Height);
			Graphics g = Graphics.FromImage(img);
			g.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceOver;
			g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;
			g.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;
			g.CompositingQuality = System.Drawing.Drawing2D.CompositingQuality.HighQuality;
			g.Clear(Color.FromArgb(0, 0, 0, 0));
			g.DrawString(text, font, new SolidBrush(colour), new Point(0, 0), StringFormat.GenericDefault);
			uint[] output = getTexture((Image)img.Clone());
			g.Dispose();
			g.Dispose();
			img.Dispose();
			return output;
		}
		
		/// <summary>
		/// Parses an int to a bool
		/// </summary>
		/// <param name="num">int to parse</param>
		/// <returns>false if 0, else true</returns>
		public static bool boolParse(int num)
		{
			if (num == 0)
				return false;
			return true;
		}
		
		/// <summary>
		/// Parses a string to a bool
		/// </summary>
		/// <param name="str">string to parse</param>
		public static bool boolParse(string str)
		{
			if (str == "0" || str.ToLower() == "false")
				return false;
			return true;
		}
		
		/// <summary>
		/// Loads an image into Graphics Card memory and returns it
		/// </summary>
		/// <param name="img">The image to load</param>
		/// <returns>uint[] representation of new texture</returns>
		public static unsafe uint[] getTexture(Image img)
		{
			
			uint[] output = new uint[1];
			
//			Bitmap bMap = new Bitmap((Image)img.Clone());
			
			int maxD;
			if (use512textureLimit)
				maxD = Math.Min(512, Math.Max(img.Width, img.Height));
			else
				maxD = Math.Max(img.Width, img.Height);
			int d = 2;
			int i = 0;
			
			while (d < maxD)
			{
				i++;
				d = (int)Math.Pow((double)i, 2.0);
			}
			
			Bitmap bMap = new Bitmap(img, new Size(d, d));
			
			System.Drawing.Imaging.BitmapData bMapData;
			Rectangle rect = new Rectangle(0, 0, bMap.Width, bMap.Height);
			
			bMapData = bMap.LockBits(rect, System.Drawing.Imaging.ImageLockMode.ReadOnly, bMap.PixelFormat);
			
			gl.glGenTextures(1, output);
			gl.glBindTexture(gl.GL_TEXTURE_2D, output[0]);
			gl.glTexParameteri(gl.GL_TEXTURE_2D, gl.GL_TEXTURE_MAG_FILTER, gl.GL_NEAREST);
			
			gl.glTexParameteri(gl.GL_TEXTURE_2D,gl.GL_TEXTURE_MIN_FILTER, gl.GL_NEAREST);
			gl.glTexParameteri(gl.GL_TEXTURE_2D, gl.GL_TEXTURE_WRAP_S, gl.GL_CLAMP);
			gl.glTexParameteri(gl.GL_TEXTURE_2D, gl.GL_TEXTURE_WRAP_T, gl.GL_CLAMP);
			gl.glPixelStorei(gl.GL_UNPACK_ALIGNMENT, 1);
			if (use16bitTextureLimit)
				gl.glTexImage2D(gl.GL_TEXTURE_2D, 0, gl.GL_RGBA16, bMap.Width, bMap.Height, 0, gl.GL_RGBA16, gl.GL_UNSIGNED_BYTE, bMapData.Scan0);
			else
				gl.glTexImage2D(gl.GL_TEXTURE_2D, 0, gl.GL_RGBA, bMap.Width, bMap.Height, 0, gl.GL_BGRA, gl.GL_UNSIGNED_BYTE, bMapData.Scan0);
			
			bMap.UnlockBits(bMapData);
			bMap.Dispose();
			
			return output;
			
		}
	}
	
}