﻿/*
 * Created by SharpDevelop.
 * User: Freddie Nash
 * Date: 20/11/2010
 * Time: 12:52
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;

namespace Planar
{
	public class VNumParser
	{
		
		double ans = 1.0;
		
		public class item
		{
			public string verb, name;
			public item obj, sbj, parent;
			public object value;
			
			public object getObject()
			{
				if (verb == "" || verb == null)
					return value;
				System.Reflection.MethodInfo mi = (meh.funcs).GetType().GetMethod(verb);
				return (double)mi.Invoke(meh.funcs, new object[] {sbj.getObject(), obj.getObject()});
			}
			
			public object getPolishObject()
			{
				if (verb == "" || verb == null)
					return value;
				System.Reflection.MethodInfo mi = (meh.funcs).GetType().GetMethod(verb);
				return (double)mi.Invoke(meh.funcs, new object[] {obj.getPolishObject(), sbj.getPolishObject()});
			}
			
			public item() { }
			
			public item(item parentN)
			{
				parent = parentN;
			}
			
			public item(double val)
			{
				value = (object)val;
			}
			
			public item(string val)
			{
				value = (object)val;
			}
		}
	
		public string tryParse(string input, bool polish, bool reverse)
		{
			string output = "FAILED!";
			try { output = parse(input, polish, reverse); } catch { }
			return output;
		}
	
		public string parse(string input, bool polish, bool reverse)
		{
		
			if (reverse)
				polish = !polish;
			
			bool res;
			double d;
			item top = new item();
			item it = top;
			
			// * -> mul is done separatly due to variables
			input = input.Replace("(", "").Replace(")", "").Replace("+", "add").Replace("- ", "sub ").Replace("/", "div").Replace("==", "eq").Replace("=", "set").Replace(">", "gt").Replace(">=", "ge").Replace("<", "lt").Replace("<=", "le").Replace("ans", ans.ToString()).Replace("epsilon", double.Epsilon.ToString()).Replace("pi", Math.PI.ToString());
			
			string[] data = input.Split(' ');
			if (reverse)
				Array.Reverse(data);
			
			for (int i = 0; i < data.Length; i++)
			{
				
				foreach (string s in meh.funcs.vars.Keys)
				{
					if (data[i] == "*" + s)
						data[i] = meh.funcs.vars[s].ToString();
				}
				if (data[i] == "*")
					data[i] = "mul";
				else if (data[i] == "rnd")
				{
					Random rnd = new Random();
					data[i] = rnd.NextDouble().ToString();
				}
			
				if (data[i][0] == '&')
				{
					if (it.obj == null)
					{
						it.obj = new item(data[i].Substring(1));
					}
					else
					{
						while (it.sbj != null)
							it = it.parent;
						it.sbj = new item(data[i].Substring(1));
						it = it.parent;
					}
					continue;
				}
				res = Double.TryParse(data[i], out d);
				if (res)
				{
					if (it.obj == null)
					{
						it.obj = new item(d);
					}
					else
					{
						while (it.sbj != null)
							it = it.parent;
						it.sbj = new item(d);
						it = it.parent;
					}
				}
				else
				{
					if (it.verb == "" || it.verb == null)
					{
						it.verb = data[i];
					}
					else if (it.obj == null)
					{
						it.obj = new item(it);
						it = it.obj;
						it.verb = data[i];
					}
					else
					{
						while (it.sbj != null)
							it = it.parent;
						it.sbj = new item(it);
						it = it.sbj;
						it.verb = data[i];
					}
				}
			}
			
			if (polish)
				ans = (double)top.getPolishObject();
			else
				ans = (double)top.getObject();
			return ans.ToString();
			
		}
		
		public static class meh
		{
			public static funcsClass funcs = new funcsClass();
		}
	
		public class funcsClass
		{
		
			public System.Collections.Generic.Dictionary<string, double> vars = new System.Collections.Generic.Dictionary<string, double>();
			
			public double set(string a, double b)
			{
				if (vars.ContainsKey(a))
					vars[a] = b;
				else
					vars.Add(a, b);
				return b;
			}
			
			// normal thingys
			
			public double add(double a, double b)
			{
				return a + b;
			}
			public double sub(double a, double b)
			{
				return a - b;
			}
			public double mul(double a, double b)
			{
				return a * b;
			}
			public double div(double a, double b)
			{
				return a / b;
			}
			public double pow(double a, double b)
			{
				return Math.Pow(a, b);
			}
			public double root(double a, double b)
			{
				return Math.Pow(a, 1.0 / b);
			}
			public double eq(double a, double b)
			{
				if (a == b)
					return 1.0;
				else
					return 0.0;
			}
			public double gt(double a, double b)
			{
				if (a > b)
					return 1.0;
				else
					return 0.0;
			}
			public double ge(double a, double b)
			{
				if (a >= b)
					return 1.0;
				else
					return 0.0;
			}
			public double lt(double a, double b)
			{
				if (a < b)
					return 1.0;
				else
					return 0.0;
			}
			public double le(double a, double b)
			{
				if (a <= b)
					return 1.0;
				else
					return 0.0;
			}
			
			// fun thingys
			
			public double pythag(double a, double b)
			{
				return Math.Sqrt(a * a + b * b);
			}
			
			// single thingys
			
			public double sign(double a, double b)
			{
				return Math.Sign(a);
			}
			public double abs(double a, double b)
			{
				return Math.Abs(a);
			}
			public double sqrt(double a, double b)
			{
				return Math.Sqrt(a);
			}
			
			public double degRad(double a, double b)
			{
				return a / 180.0 * Math.PI;
			}
			
			public double radDeg(double a, double b)
			{
				return a / Math.PI * 180.0;
			}
			
			public double sinD(double a, double b)
			{
				return Math.Sin(a / 180 * Math.PI);
			}
			public double cosD(double a, double b)
			{
				return Math.Cos(a / 180 * Math.PI);
			}
			public double tanD(double a, double b)
			{
				return Math.Tan(a / 180 * Math.PI);
			}
			public double sin(double a, double b)
			{
				return Math.Sin(a);
			}
			public double cos(double a, double b)
			{
				return Math.Cos(a);
			}
			public double tan(double a, double b)
			{
				return Math.Tan(a);
			}
		}
	
	}

}
